# This is a rare occasion when multiple inheritance is actually
# useful.  By inheriting from node_c (an ecd node) and QListViewItem
# reading, writing and displaying ecd nodes is very easy
import sys, os, string
from qt import *
from message_handler import *
from widgets import *
from StringIO import StringIO
import global_vars
HostPath = global_vars.HostPath
import ecdlib, wizutil

expanded_xpm = [
"12 7 18 1",
"       c None",
".      c #000000",
"+      c #B8C2AE",
"@      c #9DAB8F",
"#      c #82946F",
"$      c #677D50",
"%      c #4C6631",
"&      c #314E12",
"*      c #214000",
"=      c #888888",
"-      c #BBBBBB",
";      c #879976",
">      c #6C8157",
",      c #516A37",
"'      c #365318",
")      c #576F3E",
"!      c #3C581F",
"~      c #264506",
"........... ",
" .+@#$%&*.=-",
"  .;>,'*.=- ",
"   .)!*.=-  ",
"    .~.=-   ",
"     .=-    ",
"      -     "]

closed_xpm = [
"7 12 18 1",
"       c None",
".      c #000000",
"+      c #CAD2C2",
"@      c #AAB69D",
"#      c #96A587",
"$      c #899A77",
"%      c #758961",
"&      c #62784B",
"*      c #687E52",
"=      c #556D3B",
"-      c #415C25",
";      c #2E4C0F",
">      c #48622C",
",      c #345116",
"'      c #214000",
")      c #888888",
"!      c #BBBBBB",
"~      c #274607",
".      ",
"..     ",
".+.    ",
".@#.   ",
".$%&.  ",
".*=-;. ",
".>,'.)!",
".~'.)! ",
".'.)!  ",
"..)!   ",
".)!    ",
" !     "]

disabled_xpm = [
"16 11 4 1",
"       c None",
".      c #D7D7D7",
"+      c #B7B7B7",
"@      c #777777",
"                ",
"                ",
"                ",
"...........     ",
".+++++++++@     ",
".+++++++++@     ",
".+++++++++@     ",
".+++++++++@     ",
"@@@@@@@@@@@     ",
"                ",
"                "]

enabled_xpm = [
"16 13 90 1",
"       c None",
".      c #001607",
"+      c #003611",
"@      c #004315",
"#      c #003310",
"$      c #001306",
"%      c #004516",
"&      c #00A134",
"*      c #00DF49",
"=      c #00F04E",
"-      c #00D144",
";      c #008D2E",
">      c #003811",
",      c #00892C",
"'      c #00D345",
")      c #00F751",
"!      c #00EE4E",
"~      c #00E44A",
"{      c #00DE49",
"]      c #00D646",
"^      c #00AB38",
"/      c #006A22",
"(      c #004215",
"_      c #00CD43",
":      c #00F24F",
"<      c #00E74C",
"[      c #00D947",
"}      c #00D044",
"|      c #00CB42",
"1      c #00C841",
"2      c #009F34",
"3      c #00300F",
"4      c #001506",
"5      c #009931",
"6      c #00EE4D",
"7      c #00E24A",
"8      c #00CE43",
"9      c #00C13F",
"0      c #00BD3E",
"a      c #00BC3E",
"b      c #00BC3D",
"c      c #00B33A",
"d      c #006821",
"e      c #000D04",
"f      c #00C03F",
"g      c #00B83C",
"h      c #00B73B",
"i      c #00B039",
"j      c #00912F",
"k      c #001F09",
"l      c #004015",
"m      c #00C942",
"n      c #00B83B",
"o      c #009E34",
"p      c #00250B",
"q      c #00BB3D",
"r      c #00CF44",
"s      c #00C540",
"t      c #00BA3D",
"u      c #00B63B",
"v      c #00AF39",
"w      c #008C2D",
"x      c #001D08",
"y      c #001105",
"z      c #007B28",
"A      c #00C23F",
"B      c #00B93D",
"C      c #00B53B",
"D      c #00A937",
"E      c #00601F",
"F      c #000B03",
"G      c #002F0F",
"H      c #009631",
"I      c #00B73C",
"J      c #00852B",
"K      c #00260C",
"L      c #00591D",
"M      c #00A737",
"N      c #00AA37",
"O      c #00AC38",
"P      c #00A636",
"Q      c #00842B",
"R      c #004D19",
"S      c #00290D",
"T      c #005B1D",
"U      c #009430",
"V      c #000A03",
"W      c #001807",
"X      c #001D09",
"Y      c #001707",
"    .+@#$       ",
"   %&*=-;>      ",
"  ,')!~{]^/     ",
" (_:<[}_|123    ",
"4567890abbcde   ",
"+87'fghghhijk   ",
"l[]mbnnghhiop   ",
"3qrsthhghuvwx   ",
"yzA9BhhghCDEF   ",
" GHgICuuCvJK    ",
"  L;MNOOPQR     ",
"   STQUQTp      ",
"    VWXYV       "]




ecd_tags=["name", "nodetype", "type", "default_value", "prompt", "license", "help", "keeplist", 
    "min_dynamic_size", "provides", "build_requires", "build_vars",
    "requires", "requiresexpr", "srpm", "specpatch",
    "startup_time", "static_size", "storage_size",
    "value", "trideps", "choicelist", "if", "conflicts",
    "transient", "range", "build_time"]


class ECDObject(QObject):
    def __init__(self):
        QObject.__init__(self)
        self.node_map = {}
        
    def ReadECD(self, filename):
        self.filename = filename
        (dir, file) = os.path.split(self.filename)
        (self.root, node_map) = ecdlib.parse_ecd(dir, file, verbose_flag = 0)
        self.node_map = node_map.copy()

    def GetRootName(self):
        return self.root.name

    def HasNode(self, ecd_name):
        return self.node_map.has_key(ecd_name)

    def GetComponentNodeName(self):
        for key in self.node_map.keys():
            if self.node_map[key].nodetype.lower() == "component":
                return key
        return ""

    def WriteECDNode(self, node_name, fd):
        if not self.node_map.has_key(node_name):
            debug(5, "ECDObject::WriteECDNode : could not find node %s" % node_name)
            return
        node = self.node_map[node_name]
        node.write_node(fd)

    def WriteECD(self, fd):
        self.root.write_node(fd)
    
    def GetECDNodeField(self, node_name, field_name):
        if not self.node_map.has_key(node_name):
            debug(5, "ECDObject::GetECDNodeField : could not find node %s" % node_name)
            return ""
        if not field_name in ecd_tags:
            debug(5, "ECDObject::GetECDNodeField : %s is not a valid ecd field" % field_name)
            return ""
        node = self.node_map[node_name]
        #print "ECDOBject::entry field %s to value %s for node %s" % (field_name, value, node_name)
        return getattr(node, field_name, "")
    
    def SetECDNodeField(self, node_name, field_name, value):
        if not self.node_map.has_key(node_name):
            debug(5, "ECDObject::SetECDNodeField : could not find node %s" % node_name)
            return ""
        if not field_name in ecd_tags:
            debug(5, "ECDObject::GetECDNodeField : %s is not a valid ecd field" % field_name)
            return ""
        #print "ECDOBject::entry field %s to value %s for node %s" % (field_name, value, node_name)
        node = self.node_map[node_name]
        old_value = getattr(node, field_name, "")
        if old_value != value:
            self.emit(PYSIGNAL("ModifiedSignal"), ("ECD",1))
        setattr(node, field_name, value)

    def ChangeNodeName(self, old_name, new_name):
        self.node_map[new_name] = self.node_map[old_name]
        del self.node_map[old_name]
        self.node_map[new_name].name = new_name

    def RemoveNode(self, node_name):
        if not self.node_map.has_key(node_name):
            debug(5, "ECDObject::RemoveNode : could not find node %s" % node_name)
            return
        
        node = self.node_map[node_name]
        #if the node has a parent then remove itself from the childlist
        if node.parent:
            node.parent.childlist.remove(node)
        #remove the node from the dictionary
        del self.node_map[node_name]

    def GetECDNodeChildren(self, node_name):
        child_list = []
        if not self.node_map.has_key(node_name):
            debug(5, "ECDObject::GetECDNodeChildren : could not find node %s" % node_name)
            return child_list
        node = self.node_map[node_name]
        for child in node.childlist:
                child_list.append(child.name)
        return child_list

    def CreateNode(self, parent_name, node_name, node_type):
        if parent_name == "root":
            node = ecdlib.node_c(node_type, node_name)
            self.root = node
        else:
            if not self.node_map.has_key(parent_name):
                debug(5, "ECDObject::CreateNode : could not find node %s" % parent_name)
                return
            parent = self.node_map[parent_name]
            node = ecdlib.node_c(node_type, node_name, parent)
            parent.childlist.append(node)
        self.node_map[node_name] = node
        

    def PrintECD(self):
        import sys
        self.root.write_node(sys.stdout)

    #This will return all of the buildvars that are in the ECD
    def GetBuildVars(self):
        build_vars = []
        for node in self.node_map.values():
            if hasattr(node, "build_vars"):
                for line in node.build_vars.split("\n"):
                    line = line.strip()
                    if line.find("=") != -1:
                        build_var = line.split("=")[0]
                        if not build_var in build_vars:
                            build_vars.append(build_var)
        build_vars.sort()
        return build_vars


class ECDController:
    def __init__(self, main_controller, main_widget):

        self.main_controller = main_controller
        self.main_widget = main_widget
        self.SetupGUI()
        self.ecd_object = ECDObject()
        QObject.connect(self.ecd_object, PYSIGNAL("ModifiedSignal"), self.ModifiedSlot)
        self.ecd_node_item_dict = {}
        self.disconnected = 0
        self.modified = 0
        self.clipboard_node = None

    def ModifiedSlot(self, tab, status):
        self.main_controller.SetTabModified("ECD File", status)
        self.modified = status

    def GetModified(self):
        return self.modified

    def SetupGUI(self):
        #create the ecd frame
        self.ecd_frame = ECDFrame(self.main_controller, self.main_widget)
        self.split_layout = QVBoxLayout(self.ecd_frame)
        self.splitter = QSplitter(self.ecd_frame, "ecd splitter")
        self.split_layout.addWidget(self.splitter)
        
        self.ecd_node_view = ECDNodeView(self.splitter)
        QObject.connect(self.ecd_node_view, SIGNAL("selectionChanged ( QListViewItem * )"), self.NodeSelected)
        QObject.connect(self.ecd_node_view, SIGNAL("rightButtonClicked ( QListViewItem *, const QPoint &, int )"), self.NodeRightClicked) 
        
        #add what will be the root of everything
        self.embedix_node = ECDNodeViewItem("Embedix", "Embedix", "group", self.ecd_node_view)
        
        #create the frame that appears on the left side that holds ecd information
        self.ecd_info_frame = QFrame(self.splitter)
        self.ecd_info_vlayout = QVBoxLayout(self.ecd_info_frame)
        self.ecd_tab = ECDTab(self.ecd_info_frame)
        self.ecd_info_vlayout.addWidget(self.ecd_tab, 0)
        self.ecd_area_entries = ECDAreaFrame(self.ecd_info_frame)
        QObject.connect(self.ecd_area_entries, PYSIGNAL("ButtonClicked"), self.AreaButtonClicked) 
        self.ecd_info_vlayout.addWidget(self.ecd_area_entries, 1)

        QObject.connect(self.ecd_tab, PYSIGNAL("TextChanged"), self.TextChanged)
        QObject.connect(self.ecd_area_entries, PYSIGNAL("TextChanged"), self.TextChanged)
        
        self.ecd_info_vlayout.activate()

        #now activate everything
        self.split_layout.activate()
        self.ecd_frame.setEnabled(0)
    
    def ReadECD(self, filename):
        #FIXTHIS - check for existence of file
        #print "reading file", filename
        self.ClearTree()
        self.ecd_object.ReadECD(filename)
        self.ecd_node_item_dict.clear()
        
        root_name = self.ecd_object.GetRootName()
        self.AddChildNodes(self.embedix_node, [root_name])
        self.embedix_node.ExpandTree()
        self.ecd_frame.setEnabled(1)
        try:
            self.ecd_node_view.setSelected(self.ecd_node_item_dict[self.selected_name], 1)
        except AttributeError:
            self.ecd_node_view.setSelected(self.embedix_node, 1)
        self.ModifiedSlot("ECD", 0)


    def WriteECD(self, path):
        #print "ecd path", path
        ecd_fd = open(global_vars.HostPath(path), "w")
        self.ecd_object.WriteECD(ecd_fd)
        self.ModifiedSlot("ECD", 0)

    def CloseECD(self):
        self.ClearTree()
        self.NodeSelected(self.embedix_node)
        self.ecd_frame.setEnabled(0)

    def GetPackageName(self):
        return self.ecd_object.GetComponentNodeName().strip()

    def GetBuildVars(self):
        return self.ecd_object.GetBuildVars()
    
    def AddChildNodes(self, parent, children_names):
        #print "in AddChildNodes, parent is", parent, "children are", children_names
        for child_name in children_names:
            text = self.ecd_object.GetECDNodeField(child_name, "prompt")
            if text.strip() == "":
                text = self.ecd_object.GetECDNodeField(child_name, "name")
            type = self.ecd_object.GetECDNodeField(child_name, "nodetype")
            self.ecd_node_item_dict[child_name] = ECDNodeViewItem(child_name, text, type, parent)
            parent.AddChild(self.ecd_node_item_dict[child_name])
            self.AddChildNodes(self.ecd_node_item_dict[child_name], self.ecd_object.GetECDNodeChildren(child_name))

    def NodeSelected(self, list_item):
        #self.ecd_object.PrintECD()
        self.disconnected = 1
        self.selected_item_name = list_item.name
        #print "node selected", list_item.name
        #print "keys are", self.ecd_tab.attr_d.keys()
        for attr in self.ecd_tab.attr_d.keys():
            value = self.ecd_object.GetECDNodeField(list_item.name, attr)
            #print "setting entry field %s to value %s for node %s" % (attr, value, self.selected_item_name)
            self.ecd_tab.SetAttrEntryText(attr, value)
        
        for attr in self.ecd_area_entries.area_attrs:
            if self.ecd_object.GetECDNodeField(self.selected_item_name, attr).strip() != "":
                self.ecd_area_entries.SetAttrBold(attr, 1)
            else:
                self.ecd_area_entries.SetAttrBold(attr, 0)

        area_attr = self.ecd_area_entries.GetCurrentButton()
        area_text = self.ecd_object.GetECDNodeField(self.selected_item_name, area_attr).strip()
        self.ecd_area_entries.SetAttrText(area_attr, area_text)
        
        if self.selected_item_name == "Embedix":
            self.ecd_tab.setEnabled(0)
            self.ecd_area_entries.setEnabled(0)
        else:
            self.ecd_tab.setEnabled(1)
            self.ecd_area_entries.setEnabled(1)
        
        self.disconnected = 0

    def NodeRightClicked(self, list_item, point, id):
        if list_item == None:
            return
        #print "item was right clicked",
        #print list_item.name
        type = self.ecd_object.GetECDNodeField(list_item.name, "nodetype").lower()
        keeplist = self.ecd_object.GetECDNodeField(list_item.name, "keeplist")
        autovar_flag = 0
        size_flag = 0
        keeplist_flag = 0
        #only allow to add complement autovars as siblings of other options or autovars
        if type == "option" or type == "autovar":
            autovar_flag = 1
        #only allow to create keeplist for options, autovars, or components
        if type == "option" or type == "autovar" or type == "component":
            keeplist_flag = 1
        #only offer to compute size info if there is a non-empty keeplist
        if keeplist.strip() != "":
            size_flag = 1
        self.popup = ECDNodePopupMenu(self.ecd_node_view, list_item.name, create_keeplist = keeplist_flag, 
            create_complement_autovar = autovar_flag, compute_size = size_flag)
        QObject.connect(self.popup, PYSIGNAL("CutNode"), self.CutNode)
        QObject.connect(self.popup, PYSIGNAL("CopyNode"), self.CopyNode)
        QObject.connect(self.popup, PYSIGNAL("PasteNode"), self.PasteNode)
        QObject.connect(self.popup, PYSIGNAL("WriteNode"), self.WriteNode)
        QObject.connect(self.popup, PYSIGNAL("CreateComplementAutovar"), self.CreateComplementAutovar)
        QObject.connect(self.popup, PYSIGNAL("CreateKeeplist"), self.CreateKeeplist)
        QObject.connect(self.popup, PYSIGNAL("AddChild"), self.AddChild)
        QObject.connect(self.popup, PYSIGNAL("ComputeSize"), self.ComputeSize)
        self.popup.popup(point)
    
    #normally this will be called from the popup menu for nodes
    #given an ecd_name, this will create a copy (recursively) of the node
    #in the variable self.clipboard_node
    def CopyNode(self, ecd_name):
        self.clipboard_node = self.CopyNodeRecurse(ecd_name, None)

    #given the name of an ecd in the ecd_object, make a copy of it recursively
    #with the name copy_pf_<ecd_name> and return it.
    def CopyNodeRecurse(self, ecd_name, parent):
        name = ecd_name
        type = self.ecd_object.GetECDNodeField(ecd_name, "nodetype")
        copy_node = ecdlib.node_c(type, name, parent)
        for attr in copy_node.attribute_tags:
            data = self.ecd_object.GetECDNodeField(ecd_name, attr)
            if data.strip != "":
                setattr(copy_node, attr, data)
        for child_name in self.ecd_object.GetECDNodeChildren(ecd_name):
            child_node = self.CopyNodeRecurse(child_name, copy_node)
            copy_node.childlist.append(child_node)
        return copy_node
    
    #normally this will be called from the popup menu for nodes
    #given the name of an ecd in the self.ecd_object, this will add the
    #node self.clipboard_node as a child of the ecd_name node (recursively
    #as the clipboard node may have children.  This will also update the ecd node view
    #list.
    def PasteNode(self, ecd_name):
        if self.clipboard_node == None:
            QMessageBox.warning(self.ecd_frame, "Nothing in ECD Clipboard", """<qt>
            You have selected to paste a node, but there is no ECD node in the clipboard.
            Please select a node and select <b>copy</b> or <b>cut</b> from the right-click menu.
            Once the node has been copied, it can then be pasted as a child to another node.</qt>""")
            return
        self.PasteNodeRecurse(ecd_name, self.clipboard_node)

    #given the name of the parent node (that should be in the ecd_object) and an
    #actual node_c object as the ecd_node, this will add the node as a child of the
    #parent in the ecd_object.
    def PasteNodeRecurse(self, parent_name, ecd_node):
        #create a copy of the node in the ecd_object and copy over the attributes
        name = self.GetValidNodeName(ecd_node.name)
        type = ecd_node.nodetype
        self.ecd_object.CreateNode(parent_name, name, type)
        for attr in ecd_node.attribute_tags:
            data = getattr(ecd_node, attr)
            if data.strip() != "":
                self.ecd_object.SetECDNodeField(name, attr, data)
        
        #now add an item in the gui for this node
        text = getattr(ecd_node, "prompt").strip()
        if text.strip() == "":
            text = name
        parent_item = self.GetECDItem(parent_name)
        new_item = ECDNodeViewItem(name, text, type, parent_item)
        self.ecd_node_item_dict[name] = new_item
        parent_item.AddChild(new_item)
        #now do this for each of the children
        for child in ecd_node.childlist:
            self.PasteNodeRecurse(name, child)

    #try to get a valid node for an ecd_node to avoid duplicates. This only works
    #for the first 100 duplicates of a name.  That should be sufficient.
    def GetValidNodeName(self, name):
        while self.ecd_object.HasNode(name):
            if name[-1] in "012345678":
                name = name[:-1] + str(int(name[-1])+1)
            elif name[-1] == "9":
                if name[-2] in "012345678":
                    name = name[:-2] + str(int(name[-2])+1) + "0"
                else:
                    name = name[:-1] + "10"
            else:
                name = name + "2"
        return name

    def WriteNode(self, ecd_name):
        tmp_fd = StringIO()
        if ecd_name == "Embedix":
            ecd_name = self.ecd_object.GetRootName()
        self.ecd_object.WriteECDNode(ecd_name, tmp_fd)
        global_vars.log.SendHeader("Writing ECD for %s node" % ecd_name)
        global_vars.log.SendText(tmp_fd.getvalue())
        global_vars.log.SendHeader("End of  ECD for %s node" % ecd_name)

    #cut the node from the tree, but put it in the clipboard first
    def CutNode(self, ecd_name):
        self.CopyNode(ecd_name)
        self.CutNodeRecurse(ecd_name)
            
    #remove the node and all of it's children from the ecd.  This requires removing
    #both the ecd node and the graphical ecd items
    def CutNodeRecurse(self, ecd_name):
        node = self.GetECDItem(ecd_name)
        #delete the children before deleting this node
        #print "children are", self.ecd_object.GetECDNodeChildren(ecd_name)
        for child_name in self.ecd_object.GetECDNodeChildren(ecd_name):
            self.CutNode(child_name)
        self.ecd_object.RemoveNode(ecd_name)
        node.parent().takeItem(node)
        del self.ecd_node_item_dict[ecd_name]



    def ClearTree(self):
        child = self.embedix_node.firstChild()
        if child != None:
            print "cleartree::first child is", child.name
            self.CutNode(child.name)


    #create a complement autovar (a node that is automatically turned on when
    #this one is turned off)  It copies over the build_vars so that the user
    #can modify their values.
    def CreateComplementAutovar(self, ecd_name):
        parent = self.GetECDItem(ecd_name).parent()
        #print "parent name is", parent.name
        print "ecd name is", ecd_name
        name = "no_"+ecd_name
        nodetype = "autovar"
        self.ecd_object.CreateNode(parent.name, name, nodetype)
        self.ecd_object.SetECDNodeField(name, "type", "bool")
        self.ecd_object.SetECDNodeField(name, "default_value", "n")
        build_vars = self.ecd_object.GetECDNodeField(ecd_name, "build_vars")
        #print "setting build_vars to\n" + build_vars
        self.ecd_object.SetECDNodeField(name, "build_vars", build_vars)
        tmpif = "((" + ecd_name + "=='n') LET $VALUE='y')"
        self.ecd_object.SetECDNodeField(name, "if", tmpif)
        new_item = ECDNodeViewItem(name, name, nodetype, parent)
        self.ecd_node_item_dict[name] = new_item
        parent.AddChild(new_item)

    def CreateKeeplist(self, ecd_name):
        projectdir = self.main_controller.GetProjDir()
        if not projectdir:
            debug(5, "ECDController::CreateKeeplist : projectdir is missing")
            return
        package_name = self.ecd_object.GetComponentNodeName()
        tar_file = os.path.join(projectdir, "build", "tarfiles", package_name + ".tar.gz")
        if not os.path.exists(global_vars.HostPath(tar_file)):
            QMessageBox.warning(qApp.mainWidget(), "Tar File Not Found", 
            """<qt>In order to create the keeplist the list of available files
            must be retrieved from this package's tar file.  The tar file does not
            exist.  Please try rebuilding this package in the Package Editor or
            Target Wizard and select this option again.</qt>""")
            return
        (status, output) = log.ExecuteCommand("tar ztf %s " % global_vars.BuilderPath(tar_file), 1)
        if status != 0:
            QMessageBox.warning(qApp.mainWidget(), "Error Reading Tar File", 
            """<qt>In order to create the keeplist the list of available files
            must be retrieved from this package's tar file. An error occurred 
            while reading the contents of the tar file.  The error was<br><pre>%s</pre></qt>""" % output)
            return
        files = []
        for line in output.split("\n"):
            if len(line) and line[0] != "+":
                files.append(line[1:].strip()) #the [1:] changes ./stuff to /stuff
        keeplist = self.ecd_object.GetECDNodeField(ecd_name, "keeplist")
        keeplist_dialog = ECDNodeKeeplistDialog(None, files, keeplist.split())
        if keeplist_dialog.result():
            keeplist = keeplist_dialog.GetSelectedFiles()
            keeplist = string.join(keeplist, "\n")
            self.ecd_object.SetECDNodeField(ecd_name, "keeplist", keeplist)
            self.NodeSelected(self.GetECDItem(ecd_name))

    def ComputeSize(self, ecd_name):
        projectdir = self.main_controller.GetProjDir()
        if not projectdir:
            debug(5, "ECDController::ComputeSizes : projectdir is missing")
            return
        package_name = self.ecd_object.GetComponentNodeName()
        if not package_name:
            debug(5, "ECDController::ComputeSizes : package_name is missing")
            return
        command = """
        cd %(projectdir)s/build/tarfiles
        if [ ! -e "%(package_name)s.tar.gz" ]
        then
            echo %(package_name)s.tar.gz does not exist, exitting
            exit 9
        fi
        echo ===== Untarring %(package_name)s.tar.gz =======
        mkdir -p %(projectdir)s/tmp/%(package_name)s.tmp
        cd %(projectdir)s/tmp/%(package_name)s.tmp
        tar zvxf %(projectdir)s/build/tarfiles/%(package_name)s.tar.gz
        """ % vars()
        (status, output) = log.ExecuteCommand(command, 1)
        if status:
            log.SendText("There was an error unpacking the tar file %(projectdir)s/build/tarfiles/%(package_name)s.tar.gz" % vars())
            QMessageBox.critical(self.ecd_frame, "Error Untarring Package", """<qt> There was
            and error untarring the tarball for the package.  The command returned:<br><pre>%s</pre>
            <br>This must be fixed before continuing</qt>""" % output)
            return
        try:
            total_static_size = 0
            total_storage_size = 0
            bsp_config_d = wizutil.parse_config(global_vars.HostPath(projectdir + "/config-data/buildcontrol/board/bsp_config"))
            #print "bsp_config_d", bsp_config_d
            arch_prefix = bsp_config_d["cross"].strip()
            tool_path = global_vars.BuilderPath("/opt/Embedix/tools/" + arch_prefix + "/bin/")
            keeplist = self.ecd_object.GetECDNodeField(ecd_name, "keeplist")
            for line in keeplist.split("\n"):
                if len(line) == 0:
                    continue
                if line[0] == "/":
                    line = line[1:]
                file_path = os.path.join(projectdir, "tmp", package_name + ".tmp", line.strip())
                file_path = global_vars.BuilderPath(file_path)
                if not os.path.exists(global_vars.HostPath(file_path)):
                    log.SendText("%s does not exist, skipping." % file_path)
                    continue
                if os.path.isdir(file_path):
                    log.SendText("%s is a directory, skipping." % file_path)
                    continue
                if os.path.islink(file_path):
                    log.SendText("%s is a symlink, skipping." % file_path)
                    continue
                (status, output) = log.ExecuteCommand("%(tool_path)s/strip %(file_path)s; %(tool_path)s/size %(file_path)s" % vars(), 1)
                if status == 0:
                    #print output
                    out_line = output.split("\n")[4]
                    #print line
                    fields = out_line.split()
                    #print fields
                    total_static_size += int(fields[3])
                    debug(5, "static size of %s is %i" % (line.strip(), int(fields[3])))
                storage_size = os.stat(global_vars.HostPath(file_path))[6]
                total_storage_size += storage_size
                debug(5, "size of %s is %i" % (line.strip(), storage_size))
            #print "total storage size is", total_storage_size
            #print "total static size is", total_static_size
            self.ecd_object.SetECDNodeField(ecd_name, "static_size", str(total_static_size))
            self.ecd_object.SetECDNodeField(ecd_name, "storage_size", str(total_storage_size))
            self.NodeSelected(self.GetECDItem(ecd_name))
        finally:
            log.ExecuteCommand("cd %(projectdir)s/tmp; rm -rf %(package_name)s.tmp" % vars())

    def MakeMinimalECD(self, package_name, filename):
        new_ecd = ECDObject()
        new_ecd.CreateNode("root", "User Applications", "GROUP")
        new_ecd.SetECDNodeField("User Applications", "default_value", "1")
        new_ecd.CreateNode("User Applications", package_name, "COMPONENT")
        new_ecd.SetECDNodeField(package_name, "default_value", "1")
        option_name = "include_" + package_name
        new_ecd.CreateNode(package_name, option_name, "OPTION")
        new_ecd.SetECDNodeField(option_name, "default_value", "1")
        new_ecd.SetECDNodeField(option_name, "prompt", "Include %s?" % package_name)
        new_ecd.SetECDNodeField(option_name, "keeplist", "/")
        ecd_fd = open(filename, "w")
        new_ecd.WriteECD(ecd_fd)
        ecd_fd.close()
            
            
    def AddChild(self, ecd_name):
        (name, ok) = QInputDialog.getText("New Node Name", """<qt>Please enter the name for the 
        node to be added as a child to %s.  This name should be unique and should not contain 
        spaces.""" % ecd_name, "", self.ecd_frame)
        #FIXTHIS - should check for valid names
        if not ok:
            return
        name = str(name)
        nodetype = "option"
        parent_item = self.GetECDItem(ecd_name)
        self.ecd_object.CreateNode(ecd_name, name, nodetype)
        new_item = ECDNodeViewItem(name, name, nodetype, parent_item)
        self.ecd_node_item_dict[name] = new_item
        parent_item.AddChild(new_item)

    
    def AreaButtonClicked(self, attr):
        self.disconnected = 1
        text = self.ecd_object.GetECDNodeField(self.selected_item_name, attr).strip()
        self.ecd_area_entries.SetAttrText(attr, text)
        self.disconnected = 0
    
    def TextChanged(self, attr, value):
        if self.disconnected:
                return

        #we need to do some magic if the name is being changed since the node's name
        #is the key into many dictionaries.  It must be an atomic operation (thus we
        #use an input box.  Then we change the names of all objects involved
        if attr == "name":
            old_name = self.ecd_object.GetECDNodeField(self.selected_item_name, "name")
            text = value.strip()
            (new_name, ok) = QInputDialog.getText("New Node Name", "<qt>Please enter the new name for this node</qt>",
            text, self.ecd_tab, "get name box")
            new_name = str(new_name).strip()
            #check to make sure that it is a unique name, otherwise show a warning box and don't change
            #the names.
            if new_name in self.ecd_node_item_dict.keys():
                QMessageBox.warning(self.ecd_tab, "Invalid Node Name", """<qt>The name that you have
                chosen for this node, %s, is already being used by another node.  All node names must
                be unique.  If you would like to change the name of the node then please use a unique
                name.</qt>""" % new_name)
                ok = 0
            if ok:
                self.ecd_object.ChangeNodeName(old_name, new_name)
                self.ecd_node_item_dict[new_name] = self.ecd_node_item_dict[old_name]
                self.ecd_node_item_dict[new_name].name = new_name
                del self.ecd_node_item_dict[old_name]
            else:
                new_name = old_name
            self.old_disconnected = self.disconnected
            self.disconnected = 1
            self.selected_item_name = new_name
            self.ecd_tab.SetAttrEntryText("name", new_name)
            #if there is no prompt text for this node then change the graphical name
            #next to the node in the treeview
            if self.ecd_object.GetECDNodeField(new_name, "prompt") == "":
                self.GetECDItem(new_name).setText(0, new_name)
            self.disconnected = self.old_disconnected
            return

        #print "setting ECD field %s to value %s for node %s" % (attr, value, self.selected_item_name)
        self.ecd_object.SetECDNodeField(self.selected_item_name, attr, value)
        if attr == "prompt":
            if value.strip() == "":
                self.GetECDItem().setText(0, self.ecd_object.GetECDNodeField(self.selected_item_name, "name"))
            else:
                self.GetECDItem().setText(0, value)
    
        if attr == "nodetype":
            node = self.GetECDItem()
            node.setText(1, value)
        if attr in self.ecd_area_entries.area_attrs:
            if value.strip() != "":
                self.ecd_area_entries.SetAttrBold(attr, 1)
            else:
                self.ecd_area_entries.SetAttrBold(attr, 0)

    def GetECDItem(self, ecd_name = None):
        if ecd_name == None:
            ecd_name = self.selected_item_name
        return self.ecd_node_item_dict[ecd_name]
        
        
    def GetECDFrame(self):
        return self.ecd_frame


class ECDNodeKeeplistDialog(QDialog):
    def __init__(self, parent, file_list, node_file_list):
        QDialog.__init__(self, parent, "ECDNodeKeeplistDialog", 1)
        self.setCaption("Select Files for Keeplist")
        self.vl1 = QVBoxLayout(self, 10)

        self.label = QLabel("""<qt>Please select the files that you would like to include
            in the keeplist for this node.  Click <b>Ok</b> to accept the changes or <b>Cancel</b>
            to cancel your selections and exit this dialog box.</qt>""", self)
        self.vl1.addWidget(self.label)
        
        self.keeplistbox = QListBox(self, "keeplist box")
        self.vl1.addWidget(self.keeplistbox)
        self.keeplistbox.setSelectionMode(QListBox.Multi)
        self.num_items = 0
        self.items = {}
        for filename in file_list:
            #filter out this one
            if filename == "/.keepme":
                continue
            self.items[filename] = QListBoxText(self.keeplistbox, filename)
        for filename in node_file_list:
            if filename in self.items.keys():
                self.keeplistbox.setSelected(self.items[filename], 1)

        self.hl1 = QHBoxLayout(self.vl1, 10)
        self.ok_but = QPushButton("&Ok", self, "ok_button")
        self.hl1.addWidget(self.ok_but)
        QObject.connect(self.ok_but, SIGNAL("clicked()"), self.accept)
        
        self.cancel_but = QPushButton("&Cancel", self, "cancel_button")
        self.hl1.addWidget(self.cancel_but)
        QObject.connect(self.cancel_but, SIGNAL("clicked()"), self.reject)

        self.show()

    def GetSelectedFiles(self):
        selected_files = []
        for key in self.items.keys():
            if self.items[key].selected():
                selected_files.append(key)
        return selected_files


class ECDNodePopupMenu(QPopupMenu):
    def __init__(self, parent, ecd_node_name, **options):
        QPopupMenu.__init__(self, parent, "ECD Popup Menu")
        self.ecd_node_name = ecd_node_name
        self.insertItem("&Add a child to this node", self.AddChild)
        self.insertItem("&Cut", self.CutNode)
        self.insertItem("&Copy", self.CopyNode)
        self.insertItem("&Paste as child", self.PasteNode)
        self.insertItem("&Write ecd for this node to log window", self.WriteNode)
        if options.get("create_keeplist", 0):
            self.insertItem("Create &Keeplist", self.CreateKeeplist)
        if options.get("compute_size", 0):
            self.insertItem("Compute &size information from keeplist", self.ComputeSize)
        if options.get("create_complement_autovar", 0):
            self.insertItem("Create complement Autovar to this node", self.CreateComplementAutovar)
    def CutNode(self):
        self.emit(PYSIGNAL("CutNode"), (self.ecd_node_name,))
    def CopyNode(self):
        self.emit(PYSIGNAL("CopyNode"), (self.ecd_node_name,))
    def PasteNode(self):
        self.emit(PYSIGNAL("PasteNode"), (self.ecd_node_name,))
    def WriteNode(self):
        self.emit(PYSIGNAL("WriteNode"), (self.ecd_node_name,))
    def CreateComplementAutovar(self):
        self.emit(PYSIGNAL("CreateComplementAutovar"), (self.ecd_node_name,))
    def ComputeSize(self):
        self.emit(PYSIGNAL("ComputeSize"), (self.ecd_node_name,))
    def CreateKeeplist(self):
        self.emit(PYSIGNAL("CreateKeeplist"), (self.ecd_node_name,))
    def AddChild(self):
        self.emit(PYSIGNAL("AddChild"), (self.ecd_node_name,))



class ECDNodeView(QListView):
    def __init__(self, parent):
        global expanded_icon, closed_icon, enabled_icon, disabled_icon
        expanded_icon = QPixmap(expanded_xpm)
        closed_icon = QPixmap(closed_xpm)
        enabled_icon = QPixmap(enabled_xpm)
        disabled_icon = QPixmap(disabled_xpm)
        QListView.__init__(self, parent, "ECD NodeView")
        self.addColumn("Name")
        self.addColumn("Type")
        

class ECDNodeViewItem(QListViewItem):
    def __init__(self, name, text, type, parent):
        QListViewItem.__init__(self, parent)
        self.children = []
        self.name = name
        self.setText(0, text)
        self.setText(1, type)
        self.lineoGreen = QColor(33, 65, 0)
        self.setPixmap(0, enabled_icon)

    
    #this is taken directly from TW code for eqtlistviewitem
    def paintBranches(self, p, cg, w, y, h, s):
        p.fillRect(0, 0, w, h, QBrush(cg.base()))
        child = self.firstChild()
        linebot = 0
        while child != None and y + child.height() <= 0:
            y += child.totalHeight()
            child = child.nextSibling()
        bx = w/2
        while child != None and y < h:
            linebot = y + child.height() / 2
            if (child.isExpandable() or child.childCount() > 0) and child.height() > 0:
                p.setPen(self.lineoGreen.dark())
                if child.isOpen():
                    p.drawPixmap(bx-4, linebot-4, expanded_icon)
                else:
                    p.drawPixmap(bx-4, linebot-4, closed_icon)
                p.setBrush(p.NoBrush)
            y += child.totalHeight()
            child = child.nextSibling()

    def AddChild(self, child):
        self.children.append(child)

    def ExpandTree(self):
        self.setOpen(1)
        node = self.firstChild()
        while node:
            node.ExpandTree()
            node = node.nextSibling()


class ECDAreaFrame(QFrame):
    __doc__ = """
    This is a frame that contains a radio group of all the fields that need a text area
    and a corresponding text area.  Clicking on a different radio group option updates
    the contents of the text area.  It maintains it's own dictionary (self.database) that
    holds the text for each radio group entry """
    area_attrs = ["help", "keeplist", "provides", "build_requires", "build_vars",
        "requires", "requiresexpr", "choicelist", "if", "conflicts", "license"]
    area_attrs_d = {"help": "help", "requires": "requires", "provides": "provides",
        "conflicts": "conflicts", "ifstack": "ifstack", "requiresexpr" : "requiresexpr",
        "if": "if",  "build_requires": "build_requires", "build_vars": "build_vars",
        "keeplist": "keeplist", "choicelist": "choicelist", "license": "license"}

    def __init__(self, parent, name = "ECDAreaFrame"):
        global debug, log
        debug = global_vars.get("debug")
        log = global_vars.get("log")
        self.parent = parent
        QFrame.__init__(self, parent, name)
        self.grid_layout = QGridLayout(self, 2, 2, 10)

        #set up the radio group, field_d is a mapping of field name to field description
        self.radio_group = QVButtonGroup("Attributes", self, name)
        self.vradio_layout = QVBoxLayout()
        self.radio_buttons = {}
        for item in self.area_attrs:
            self.radio_buttons[item] = ColorableRadioButton(self.radio_group, item)
            self.radio_buttons[item].setText(self.area_attrs_d[item])
            qs = self.radio_buttons[item].sizeHint()
            qs.setWidth(qs.width() + 20)
            self.radio_buttons[item].setMinimumSize(qs)
            self.vradio_layout.addWidget(self.radio_buttons[item])

        #now set the first radio group and add this group to the grid layout
        self.radio_buttons[self.area_attrs[0]].setOn(1)
        self.radio_group.setMinimumSize(self.radio_group.sizeHint())
        self.grid_layout.addMultiCellWidget(self.radio_group, 0, 1, 0, 0)

        #add the text area and label to the widget
        self.text_area = QMultiLineEdit(self, "ECD area entry box")
        self.text_area.setText("")
        self.grid_layout.addWidget(self.text_area, 1, 1)
        self.label = QLabel("Attribute Title", self)
        self.grid_layout.addWidget(self.label, 0, 1)

        #connect signals to methods, set the current field and act like it was just
        #clicked
        QObject.connect(self.radio_group, SIGNAL("clicked(int)"), self.ClickedSlot)
        QObject.connect(self.text_area, SIGNAL("textChanged()"), self.TextChanged)
        self.current_attr = self.area_attrs[0]
        self.cur_node = None
        self.modify_flag = 1
        self.field_dict = {}
        

    def SetAttrText(self, attr, text):
        self.label.setText(self.area_attrs_d[attr])
        self.text_area.setText(text)

    def SetAttrBold(self, attr, value):
        self.radio_buttons[attr].setBold(value)

    def TextChanged(self):
        __doc__ = "this is called when the text changes.it just updates the database value"
        # get the value and the attribute, then set it in the node
        value = str(self.text_area.text())
        attribute = self.GetCurrentButton()
        self.emit(PYSIGNAL("TextChanged"), (attribute, str(value)))
        self.field_dict[self.current_attr] = value.strip()

    def GetCurrentButton(self):
        selected_attr = ""
        for attr in self.area_attrs:
            if self.radio_buttons[attr].isOn():
                selected_attr = attr
                break 
        if not selected_attr in self.area_attrs:
            print "Error in ECDAreaEntry::GetCurrentButton"
        return selected_attr
            
    def ClickedSlot(self, id):
        __doc__ = """
        This is called when a user clicks on a button in the radio group.  It figures out which button
        was selected and updates the text area for the new selected field"""
        selected_attr = ""
        for attr in self.area_attrs:
            if self.radio_buttons[attr].isOn():
                selected_attr = attr
                break
        if not selected_attr in self.area_attrs:
            print "Error in ECDAreaEntry::ClickedSlot"
        self.emit(PYSIGNAL("ButtonClicked"), (selected_attr,))
    
    def Clear(self):
        self.SetText("")
        for item in self.area_attrs:
            self.radio_buttons[item].setBold(0)


class ECDEntry(QFrame):
    __doc__ = """
    This is just a compound widget that has a label and an entry field.  Used for
    one line fields in the lbc editor
    """
    def __init__(self, parent, attr, name):
        QFrame.__init__(self, parent, name)
        self.parent = parent
        self.name = name
        self.attr = attr
        self.label = QLabel(self.name, self)
        self.line_edit = QLineEdit(self)
        QObject.connect(self.line_edit, SIGNAL("textChanged(const QString &)"), self.TextChanged)
        self.vlayout = QVBoxLayout(self)
        self.vlayout.addWidget(self.label, 0)
        self.vlayout.addWidget(self.line_edit, 0)
    
    def TextChanged(self, text):
        value = str(self.line_edit.text())
        self.emit(PYSIGNAL("TextChanged"), (self.name, str(text)))
    
    def GetText(self):
        return str(self.line_edit.getText())
    
    def SetText(self, text, modifying = 0):
        self.modify_flag = modifying
        self.line_edit.setText(text)
        self.modify_flag = 1
    
    def Clear(self):
        self.SetText("")


class ECDListBox(QFrame):
    __doc__ = """
    this is a drop_down listbox
    """
    def __init__(self, parent, attr, name, options):
        self.parent = parent
        self.name = name
        self.attr = attr
        self.options = options
        QFrame.__init__(self, parent, name)

        self.label = QLabel(self.name, self)
        self.list_box = QComboBox(self, "listbox for %s" % self.name)

        for option in self.options:
            self.list_box.insertItem(option)

        self.vlayout = QVBoxLayout(self)
        self.vlayout.addWidget(self.label, 0)
        self.vlayout.addWidget(self.list_box, 0)
        QObject.connect(self.list_box, SIGNAL("activated(const QString &)"), self.TextChanged)

    def TextChanged(self, new_text):
        value = str(self.list_box.currentText())
        self.emit(PYSIGNAL("TextChanged"), (self.name, str(new_text)))
            
    def SetOption(self, option, modifying = 0):
        option = option.lower().strip()
        #print "option is", option
        try:
            self.list_box.setCurrentItem(self.options.index(option))
        except:
            self.list_box.setCurrentItem(0)

    def Clear(self):
        self.SetOption("")



class ECDTab(QTabWidget, HandlerChild):
    line_attrs =     ["default_value", "min_dynamic_size", "prompt", "srpm", "specpatch",
        "startup_time", "static_size", "storage_size", "type", "value", "trideps",
        "transient", "range", "build_time", "name", "nodetype"]
    node_attrs =     ["nodetype", "name", "prompt"]
    nodetype_options = ["group", "component", "option", "autovar"]
    value_attrs =    ["type", "default_value", "range", "value"]
    type_options = ["", "int", "int.oct", "int.hex", "string", "bool", "tristate"]
    file_attrs =     ["filename", "srpm", "specpatch"]
    size_attrs =    ["storage_size", "static_size", "min_dynamic_size", "transient"]
    time_attrs =    ["build_time", "startup_time"]
    attr_d = {"type": "type", "name": "name", "prompt": "prompt", "default_value": "default_value",
        "filename": "filename", "srpm": "srpm", "static_size": "static_size",
        "storage_size": "storage_size", "nodetype": "nodetype", "specpatch": "specpatch",
        "range": "range", "value": "value", "min_dynamic_size": "min_dynamic_size",
        "transient": "transient", "build_time": "build_time", "startup_time": "startup_time"}
    def __init__(self, parent, name = "ECDTab"):
        QTabWidget.__init__(self, parent, name)
        self.parent = parent
        self.node_frame = QFrame(self, "ECDTab::NodeFrame")
        self.addTab(self.node_frame, "Node")
        self.value_frame = QFrame(self, "ECDTab::ValueFrame")
        self.addTab(self.value_frame, "Value")
        self.file_frame = QFrame(self, "ECDTab::FileFrame")
        self.addTab(self.file_frame, "File")
        self.size_frame = QFrame(self, "ECDTab::SizeFrame")
        self.addTab(self.size_frame, "Size")
        self.time_frame = QFrame(self, "ECDTab::TimeFrame")
        self.addTab(self.time_frame, "Time")

        self.attr_entries = {}
        for attr in self.node_attrs:
            if attr == "nodetype":
                self.attr_entries[attr] = ECDListBox(self.node_frame, attr, self.attr_d[attr], self.nodetype_options)
            else:
                self.attr_entries[attr] = ECDEntry(self.node_frame, attr, self.attr_d[attr])
        
        self.node_layout = QGridLayout(self.node_frame, 2, 2, 10, 10, "ecd tab node layout")
        self.node_layout.addWidget(self.attr_entries["name"], 0, 0)
        self.node_layout.addWidget(self.attr_entries["nodetype"], 1, 0)
        self.node_layout.addWidget(self.attr_entries["prompt"], 0, 1)
        
        for attr in self.value_attrs:
            if attr == "type":
                self.attr_entries[attr] = ECDListBox(self.value_frame, attr, self.attr_d[attr], self.type_options)
            else:
                self.attr_entries[attr] = ECDEntry(self.value_frame, attr, self.attr_d[attr])
        
        self.value_layout = QGridLayout(self.value_frame, 2, 2, 10, 10, "ecd tab value layout")
        self.value_layout.addWidget(self.attr_entries["type"], 0, 0)
        self.value_layout.addWidget(self.attr_entries["default_value"], 1, 0)
        self.value_layout.addWidget(self.attr_entries["range"], 0, 1)
        self.value_layout.addWidget(self.attr_entries["value"], 1, 1)
        
        for attr in self.file_attrs:
            self.attr_entries[attr] = ECDEntry(self.file_frame, attr, self.attr_d[attr])
        
        self.file_layout = QGridLayout(self.file_frame, 2, 2, 10, 10, "ecd tab file layout")
        self.file_layout.addWidget(self.attr_entries["filename"], 0, 0)
        self.file_layout.addWidget(self.attr_entries["srpm"], 1, 0)
        self.file_layout.addWidget(self.attr_entries["specpatch"], 0, 1)
        
        for attr in self.size_attrs:
            self.attr_entries[attr] = ECDEntry(self.size_frame, attr, self.attr_d[attr])
        
        self.size_layout = QGridLayout(self.size_frame, 2, 2, 10, 10, "ecd tab size layout")
        self.size_layout.addWidget(self.attr_entries["storage_size"], 0, 0)
        self.size_layout.addWidget(self.attr_entries["static_size"], 1, 0)
        self.size_layout.addWidget(self.attr_entries["min_dynamic_size"], 0, 1)
        self.size_layout.addWidget(self.attr_entries["transient"], 1, 1)

        for attr in self.time_attrs:
            self.attr_entries[attr] = ECDEntry(self.time_frame, attr, self.attr_d[attr])
        self.time_layout = QGridLayout(self.time_frame, 2, 2, 10, 10, "ecd tab time layout")
        self.time_layout.addWidget(self.attr_entries["build_time"], 0, 0)
        self.time_layout.addWidget(self.attr_entries["startup_time"], 0, 1)

        #now connect all of the signals to this slot
        for attr_entry in self.attr_entries.values():
            QObject.connect(attr_entry, PYSIGNAL("TextChanged"), self.TextChanged)

    def Clear(self):
        for key in self.attr_entries.keys():
            self.attr_entries[key].Clear()

    def TextChanged(self, attribute, text):
        #print "tab emitting textchanged", attribute, text
        self.emit(PYSIGNAL("TextChanged"), (attribute, text))
    
    def SetAttrEntryText(self, attr, text):
        if isinstance(self.attr_entries[attr], ECDEntry):
            self.attr_entries[attr].SetText(text)
        elif isinstance(self.attr_entries[attr], ECDListBox):
            self.attr_entries[attr].SetOption(text)
            

class ECDFrame(QFrame):
    def __init__(self, parent, main_win):
        self.name = "ecd_frame"
        self.main = main_win
        QFrame.__init__(self, parent, "ECD Frame")
        self.modified = 0

    def Close(self):
        return
        if self.modified:
            answer = QMessageBox.warning(self, "ECD File has changed!",
                """<qt>You have made modifications to the ECD for this package.  Would you
                like to save those changes?</qt>""", "&Yes", "&No", "", 0, 1)
            #if they anwered yes
            if answer == 0:
                self.WriteECD()
        self.ecd_view.ClearNodes()
        self.ecd_tab.Clear()
        self.ecd_area_entries.Clear()
        self.SetModified(0)
        self.setEnabled(0)
    
    def MakeMinimalECD(self):
        global nodemap
        nodemap = {}
        projectdir = self.main.GetProjDir()
        if not projectdir:
            debug(5, "ECDFrame::MakeMinimalECD : projectdir is missing")
            return
        package_name = self.main.GetPackageName()
        if not package_name:
            debug(5, "ECDFrame::MakeMinimalECD : package_name is missing")
            return

        root_node = ecdlib.node_c("GROUP", "User Applications")
        component_node = ecdlib.node_c("COMPONENT", package_name, root_node)
        root_node.childlist = [component_node]
        option_node = ecdlib.node_c("OPTION", "include_" + package_name, component_node)
        option_node.prompt = "Include %s?" % package_name
        option_node.keeplist = "/"
        component_node.childlist = [option_node]
        
        ecd_name = HostPath(os.path.join(projectdir, "config-data/ecds/local", package_name + ".ecd"))
        ecd_fd = open(ecd_name, "w")
        root_node.write_node(ecd_fd)
        ecd_fd.close()
        self.main.SetECDName(ecd_name)
        self.SetModified(0)


   
