import sys, re

if sys.platform.find("win") != -1:
    host = "windows"
elif sys.platform.find("linux") != -1:
    host = "linux"
else:
    print "Error: in global_vars, could not determine platform type"

#windows home drive
home_drive = "P:"
#windows /opt/Embedix drive
opt_emb_drive = "Q:"
ip = ""


d = {}


def SetProjDir(a_proj_dir):
    global proj_dir
    proj_dir = a_proj_dir
    d["proj_dir"] = proj_dir


def Setlog(a_log):
    global log
    log = a_log
    d["log"] = a_log

def SetBuilder(a_builder):
    global builder
    builder = a_builder
    d["builder"] = builder

def Setdebug(a_debug):
    global debug
    debug = a_debug
    d["debug"] = a_debug

def Sethandler(a_handler):
    global handler
    handler = a_handler
    d["handler"] = a_handler

def SetSettings(a_settings):
    global settings
    settings = a_settings
    d["settings"] = a_settings

def get(key):
    return globals()[key]

def IsValidFilename(fn):
    """This checks a filename to see if it is valid to use"""
    if fn.strip() == "":
        return 0
    return 1

def HostPath(path):
    #print "HostPath called with", path
    if host == "linux":
        return path
    if host == "windows":
        path = path.replace("/", "\\")
        #check to see if it includes an absolute path
        path = re.sub(r"([A-Za-z]:)?\\home\\vkit", home_drive, path)
        path = re.sub(r"([A-Za-z]:)?\\opt\\Embedix", opt_emb_drive, path)
        #print "returning", path
        return path

def BuilderPath(path):
    #print "BuilderPath called with", path
    if host == "linux":
        return path
    if host == "windows":
        path = path.replace("\\", "/")
        #fixthis - it should not be hard coded
        path = re.sub(r"[" + home_drive.upper() + home_drive.lower() + r"]:", r"/home/vkit/", path)
        path = re.sub(r"[" + opt_emb_drive.upper() + opt_emb_drive.lower() + "]:", r"/opt/Embedix/", path)
        #print "returning", path
    return path






