#!/usr/local/bin/runwiz
from qt import *
import sys
sys.path.append("/opt/Embedix/emb-bin")
import ecdlib, wizutil
import os, glob, types, commands, re
import popen2, time, tempfile, shutil
import global_vars, widgets, shellprox
HostPath = global_vars.HostPath
BuilderPath = global_vars.BuilderPath

from lbc import *
from ecd import *
from message_handler import *
from source import *
from builder import *
from settings import *

if global_vars.host == "linux":
    import fcntl, FCNTL

#DESCRIPTION: Package editor - Allows editting of package lbc, ecd, and source files

#mapping of field names to field descriptions
field_d = {"pkg_file": "Package File", "patches": "Patches", "bld_dir_name": "Build Directory Name",
        "cflags": "Compile Flags", "cfgopts": "Configuration Options", "makec": "Make Configure",
        "makeb": "Make Build", "makei": "Make Install", "bin": "Binary", "bld_targ": "Build Target",
        "makerc": "Make Re-Configure", "makest": "Make Stage Components", "makedc": "Make Clean",
        "spec": "Spec Filename"}
fields = ["pkg_file", "patches", "bld_dir_name", "cflags", "cfgopts", "spec", "bin", "bld_targ",
    "makec", "makerc", "makeb", "makei", "makest", "makedc"]

pixmap_dir = "/opt/Embedix/embedix-2.0/wizards/"
#helper functions
##################################### pixmaps ###############################3
twlogo_xpm = [
"32 31 249 2",
"      c None",
".     c #121E09",
"+     c #111B08",
"@     c #0A1105",
"#     c #040602",
"$     c #000000",
"%     c #020202",
"&     c #1B2017",
"*     c #32382C",
"=     c #1D2416",
"-     c #0A1104",
";     c #040702",
">     c #10110E",
",     c #415035",
"'     c #4A6435",
")     c #415A2D",
"!     c #1A2213",
"~     c #101A08",
"{     c #0A1004",
"]     c #030401",
"^     c #090A07",
"/     c #292F23",
"(     c #2C3226",
"_     c #11190A",
":     c #080D03",
"<     c #020301",
"[     c #040403",
"}     c #445536",
"|     c #5F8740",
"1     c #487725",
"2     c #4A7828",
"3     c #15210D",
"4     c #0F1908",
"5     c #090F04",
"6     c #11140E",
"7     c #30362A",
"8     c #22291B",
"9     c #0C1406",
"0     c #060A03",
"a     c #010100",
"b     c #10130D",
"c     c #5A7841",
"d     c #4A7927",
"e     c #3A5E1F",
"f     c #000100",
"g     c #0F1807",
"h     c #080E04",
"i     c #020201",
"j     c #1C2117",
"k     c #32372C",
"l     c #192111",
"m     c #0B1205",
"n     c #181C14",
"o     c #5A7E3E",
"p     c #477625",
"q     c #477525",
"r     c #010201",
"s     c #040503",
"t     c #22281C",
"u     c #2E3428",
"v     c #141D0C",
"w     c #030501",
"x     c #151911",
"y     c #567B39",
"z     c #315119",
"A     c #14210A",
"B     c #070B03",
"C     c #111C09",
"D     c #3C631F",
"E     c #0D1607",
"F     c #060705",
"G     c #282E23",
"H     c #2A3124",
"I     c #111B09",
"J     c #0C0E0A",
"K     c #55783A",
"L     c #416B21",
"M     c #18260D",
"N     c #12160E",
"O     c #0B1306",
"P     c #487626",
"Q     c #080A06",
"R     c #2A3023",
"S     c #252D1E",
"T     c #091004",
"U     c #020401",
"V     c #020302",
"W     c #516E3A",
"X     c #3A601E",
"Y     c #232E1A",
"Z     c #3C4A2F",
"`     c #070A05",
" .    c #3B6020",
"..    c #0D1506",
"+.    c #090B07",
"@.    c #2B3225",
"#.    c #232B1C",
"$.    c #3D502E",
"%.    c #2C3922",
"&.    c #324125",
"*.    c #304B1B",
"=.    c #0B0D09",
"-.    c #2C3326",
";.    c #222A1A",
">.    c #1E2618",
",.    c #527E30",
"'.    c #3E6720",
").    c #2B3920",
"!.    c #354925",
"~.    c #2B4119",
"{.    c #2D3427",
"].    c #202919",
"^.    c #101B08",
"/.    c #050604",
"(.    c #527536",
"_.    c #457123",
":.    c #233118",
"<.    c #3F592B",
"[.    c #010200",
"}.    c #213213",
"|.    c #1F2917",
"1.    c #394C29",
"2.    c #497726",
"3.    c #203311",
"4.    c #4B6834",
"5.    c #1D2A12",
"6.    c #0B1305",
"7.    c #030602",
"8.    c #0F130C",
"9.    c #527C32",
"0.    c #304F18",
"a.    c #3C512B",
"b.    c #1B2B0E",
"c.    c #0C1009",
"d.    c #050703",
"e.    c #040603",
"f.    c #131C0C",
"g.    c #3F582B",
"h.    c #436E22",
"i.    c #1F2A16",
"j.    c #416228",
"k.    c #030502",
"l.    c #212B19",
"m.    c #131A0D",
"n.    c #12180E",
"o.    c #507C2F",
"p.    c #1E310F",
"q.    c #476530",
"r.    c #131F09",
"s.    c #28351D",
"t.    c #030402",
"u.    c #0C1107",
"v.    c #3D5629",
"w.    c #3B621E",
"x.    c #1E2817",
"y.    c #3E6123",
"z.    c #0D100A",
"A.    c #28371C",
"B.    c #040802",
"C.    c #0A0D07",
"D.    c #517B30",
"E.    c #17270C",
"F.    c #43612C",
"G.    c #1B2C0D",
"H.    c #344824",
"I.    c #304221",
"J.    c #11170D",
"K.    c #4C762C",
"L.    c #080C05",
"M.    c #3E5A28",
"N.    c #010101",
"O.    c #496E2E",
"P.    c #1C2E0E",
"Q.    c #2F4320",
"R.    c #325319",
"S.    c #222E18",
"T.    c #273F15",
"U.    c #141B0E",
"V.    c #4D7B2B",
"W.    c #426D22",
"X.    c #45682A",
"Y.    c #203510",
"Z.    c #344D21",
"`.    c #0C1108",
" +    c #060903",
".+    c #2D411E",
"++    c #2B4716",
"@+    c #4E7B2D",
"#+    c #131F0A",
"$+    c #3E6124",
"%+    c #203410",
"&+    c #262E1F",
"*+    c #0B1007",
"=+    c #426329",
"-+    c #1A2512",
";+    c #497827",
">+    c #416625",
",+    c #3B5E20",
"'+    c #040502",
")+    c #0C0D0B",
"!+    c #445337",
"~+    c #10150C",
"{+    c #1F2718",
"]+    c #4C772C",
"^+    c #447023",
"/+    c #243417",
"(+    c #0C1306",
"_+    c #36571D",
":+    c #598239",
"<+    c #56783B",
"[+    c #091005",
"}+    c #2A3520",
"|+    c #10160B",
"1+    c #4B7929",
"2+    c #34551A",
"3+    c #233514",
"4+    c #17250C",
"5+    c #33541A",
"6+    c #253C13",
"7+    c #38462D",
"8+    c #1C2812",
"9+    c #263F13",
"0+    c #1F3012",
"a+    c #3B5D21",
"b+    c #1C2018",
"c+    c #4D633B",
"d+    c #0C1008",
"e+    c #233216",
"f+    c #1D2F0F",
"g+    c #0C1307",
"h+    c #537B35",
"i+    c #5C7E40",
"j+    c #47662F",
"k+    c #080D05",
"l+    c #223214",
"m+    c #16250B",
"n+    c #395E1D",
"o+    c #1D300F",
"p+    c #1A270F",
"q+    c #19290D",
"r+    c #0A1005",
"s+    c #243A13",
"t+    c #36591C",
"u+    c #3C6220",
"v+    c #3D641F",
"w+    c #354D22",
"x+    c #0D110B",
"y+    c #0E1707",
"z+    c #161E10",
". . . + @ # $ $ $ % & * = - ; $ $ $ $ > , ' ) ! $ $ $ $ $ $ $ $ ",
". . ~ { ] $ $ $ ^ / ( _ : < $ $ $ [ } | 1 1 1 2 3 $ $ $ $ $ $ $ ",
". 4 5 < $ $ $ 6 7 8 9 0 a $ $ $ b c d 1 1 1 1 1 e f $ $ $ $ $ $ ",
"g h i $ $ i j k l m ; $ $ $ $ n o 1 1 1 1 p 1 1 q 0 $ $ $ $ $ $ ",
"h r $ $ s t u v - w $ $ $ $ x y 1 1 p z A B C D 1 E $ $ $ $ $ $ ",
"r $ $ F G H I - ] $ $ $ $ J K 1 1 L M / N $ $ O P . $ $ $ $ $ $ ",
"$ $ Q R S ~ T U $ $ $ $ V W 1 1 X Y Z ` $ $ $ $  ...$ $ $ $ $ $ ",
"$ +.@.#.4 5 < $ $ $ $ $ $.d 1 X %.&.f $ $ $ $ $ *.B $ $ $ $ $ $ ",
"=.-.;.~ T < $ $ $ $ $ >.,.1 '.).!.f $ $ $ $ $ $ ~.r $ $ $ $ $ $ ",
"{.].^.{ < $ $ $ $ $ /.(.1 _.:.<.[.$ $ $ $ $ $ $ }.$ $ $ $ $ $ $ ",
"|.C @ U $ $ $ $ $ $ 1.2.1 3.4.B $ $ $ $ $ $ $ $ 5.$ $ $ $ $ $ $ ",
"C 6.7.$ $ $ $ $ $ 8.9.1 0.a.b.c.d.$ $ $ $ $ $ e.f.$ $ $ $ $ $ $ ",
"9 ; $ $ $ $ $ $ $ g.1 h.i.j.k.l.$ $ $ $ $ $ $ m.a $ $ $ $ $ $ $ ",
"0 $ $ $ $ $ $ $ n.o.1 p.q.r.s.t.$ $ $ $ $ $ $ u.$ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ v.1 w.x.y.z.A.$ $ $ $ $ $ $ f B.$ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ C.D.1 E.F.G.H.0 $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ I.1 w.J.K.L.M.$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ N.O.1 P.Q.R.S.T.$ $ $ $ $ $ r $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ U.V.W.# X.Y.Z.P.$ $ $ $ `. +N.$ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ .+1 ++C.@+#+$+%+$ $ $ &+z.*+$ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ =+1 r.-+;+9 >+,+'+)+!+~+{+$ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ k.]+^+] /+1 (+_+1 :+<+[+}+k.$ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ |+1+2+$ 3+1 4+g 5+6+ +7+C.$ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ t.N.$ $ 8+2.9+$ 0+1 a+e.$ b+c+d+$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"# # $ $ $ e+1 f+$ g+q 1 h+i+j+B $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"k+$ $ $ $ l+1 m+$ $ %+'.n+o+< $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"a $ $ $ $ p+1 q+$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ r+P s+$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ t+u+a $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ @ v+w+x+V $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ r y+z+d.$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ "]

lbc_open_xpm = [
"16 13 8 1",
"       c None",
".      c #DCDCDC",
"+      c #000000",
"@      c #F3F7F3",
"#      c #5600B0",
"$      c #F3F704",
"%      c #040404",
"&      c #808304",
".++++++++++++...",
"+@#@$##@$@##$%..",
"+$#$@#@#@#@$@%..",
"+@#@$##@$#$@$%..",
"%$#$@#@#@#@$@%..",
"%@##$##@$@##$%..",
"%$@$@$@$@$@$@%..",
"%@$@$%%++%%+%%%%",
"%$@$+&&&&&&&&&%.",
"%@$%&&&&&&&&&+..",
"%$%&&&&&&&&&%...",
"%%&&&&&&&&&%....",
"%%%%%%%%%%%....."
]
lbc_save_xpm = [
"16 16 8 1",
"       c None",
".      c #DCDCDC",
"+      c #000000",
"@      c #2F2F2F",
"#      c #FFFFFF",
"$      c #5600B0",
"%      c #9E9E9E",
"&      c #3F3F3F",
".++++++++++++++.",
"+@@@@@@@@@@@@@@+",
"+@############@+",
"+@#$##$$###$$#@+",
"+@#$##$#$#$###@+",
"+@#$##$$##$###@+",
"+@#$##$#$#$###@+",
"+@#$$#$$###$$#@+",
"+@############@+",
"+@@@@@@@@@@@@@@+",
"+@@@%%%%%%%%@@@+",
"+@@@%&&%%%%%@@@+",
"+@@@%&&%%%%%@@@+",
"+@@@%&&%%%%%@@@+",
".+@@ %%%%%%%@@@+",
"..+++++++++++++."
]
ecd_open_xpm = [
"16 13 8 1",
"       c None",
".      c #DCDCDC",
"+      c #000000",
"@      c #040404",
"#      c #F3F7F3",
"$      c #5600B0",
"%      c #F3F704",
"&      c #808304",
".++++++++++++@..",
"+#$$%#$$%$$#%#@.",
"+%$%#$#%#$#$#%@.",
"+#$$%$%#%$%$%#@.",
"@%$%#$#%#$#$#%@.",
"@#$$%#$$%$$#%#@.",
"@%#%#%#%#%#%#%@.",
"@#%#%@@++@@+@@@@",
"@%#%+&&&&&&&&&@.",
"@#%@&&&&&&&&&+..",
"@%@&&&&&&&&&@...",
"@@&&&&&&&&&@....",
"@@@@@@@@@@@....."
]
ecd_save_xpm = [
"16 16 8 1",
"       c None",
".      c #DCDCDC",
"+      c #000000",
"@      c #2F2F2F",
"#      c #FFFFFF",
"$      c #5600B0",
"%      c #9E9E9E",
"&      c #3F3F3F",
".++++++++++++++.",
"+@@@@@@@@@@@@@@+",
"+@############@+",
"+@#$$##$$#$$##@+",
"+@#$##$###$#$#@+",
"+@#$$#$###$#$#@+",
"+@#$##$###$#$#@+",
"+@#$$##$$#$$##@+",
"+@############@+",
"+@@@@@@@@@@@@@@+",
"+@@@%%%%%%%%@@@+",
"+@@@%&&%%%%%@@@+",
"+@@@%&&%%%%%@@@+",
"+@@@%&&%%%%%@@@+",
".+@@ %%%%%%%@@@+",
"..+++++++++++++."
]
source_save_xpm = [
"16 16 8 1",
"       c None",
".      c #DCDCDC",
"+      c #000000",
"@      c #2F2F2F",
"#      c #FFFFFF",
"$      c #5600B0",
"%      c #9E9E9E",
"&      c #3F3F3F",
".++++++++++++++.",
"+@@@@@@@@@@@@@@+",
"+@############@+",
"+@######$$####@+",
"+@#####$######@+",
"+@#####$######@+",
"+@#####$######@+",
"+@###$##$$####@+",
"+@############@+",
"+@@@@@@@@@@@@@@+",
"+@@@%%%%%%%%@@@+",
"+@@@%&&%%%%%@@@+",
"+@@@%&&%%%%%@@@+",
"+@@@%&&%%%%%@@@+",
".+@@ %%%%%%%@@@+",
"..+++++++++++++."
]

stop_xpm = [
"16 16 12 1",
"       c None",
".      c #626162",
"+      c #000000",
"@      c #4A484A",
"#      c #FF698B",
"$      c #FF4873",
"%      c #DE004A",
"&      c #FFB2C5",
"*      c #FFD6E6",
"=      c #FF8DAC",
"-      c #940031",
";      c #FF2452",
"    .++++++.    ",
"   @+######+@   ",
"  +#$%%%%%%%#+  ",
" @#$%%%%%%%%%#@ ",
".+$%%%%%%%%%%%+.",
"+#**%***%**%**%+",
"+#*%%%*%%**%**-+",
"+#**%%*%%**%*%-+",
"+#%*%%*%%**%*%-+",
"+#**%%*%%**%*%-+",
"+%%%%%%%%%%%%%-+",
".+%%%%%%%%%%%%+@",
" @-%%%%%%%%%%-+ ",
"  +-%%%%%%%%-+  ",
"   @+------++   ",
"    .++++++@    "]
################################ end of pixmaps ############################





def ParseArgs(arg_list):
    "Parse arguments from the commands line into dictionary form"
    option_dict = {}
    
    option_dict["help"] = ("-h", "--help")
    option_dict["dir"] = ("-d", "-pd", "--pd", "--projdir", "--projectdir")
    option_dict["pkg"] = ("-p", "--pkg", "-pkg", "--package")
    option_dict["ip"] = ("-i", "--ip")
    option_dict["drives"] = ("--drives",)

    #list of options that take values after them
    value_options = ("pkg", "dir", "ip", "drives")
    arg_dict = {}
    
    status_flag = 1
    i = 0
    while i+1 < len(arg_list):
        i = i + 1
        ate_arg = 0
        for key in option_dict.keys():
            arg = arg_list[i]
            if arg in option_dict[key]:
                ate_arg = 1
                
                #if this argument is already in the dictionary then
                #tell the user
                if key in arg_dict.keys():
                    status_flag = 0
                    print "duplicate argument:", arg
                    break
                    
                #if this option expects a following arg then look for it
                #and throw an error otherwise
                value = 1
                if key in value_options:
                    if i+1 < len(arg_list) and arg_list[i+1][0] != "-":
                        i = i + 1
                        value = arg_list[i]
                    else:
                        status_flag = 0
                        print "Error: no value given for option", arg
                arg_dict[key] = value
                break
        #if we never ate the argument then tell the user
        if ate_arg == 0:
            status_flag = 0
            print "Unrecognized option:", arg

    return (status_flag, arg_dict)

debug_level = 0
def debug(level, *strings):
    "Send debug messages to the console with a certain debug level"
    global main_win
    if level <= debug_level:
        for item in strings:
            try:
                main_win.log.SendText(str(item) + "\n")
            except:
                print str(item)

def LogMsg(message):
    "Send a message to the log window of the Package editor"
    global main_win
    try:
        main_win.log.SendText(message + "\n")
    except:
        print message


class ImportSourceDialog(QDialog, HandlerChild):
    """This is the dialog that appears when someone want to create a new package
    from an existing source tree import.
    It asks for the name of the package and the path to the source for the package"""
    def __init__(self, parent):
        """The constructor calls the parents' constructors and lays out the widgets.
        It must have a parent (usually this is the QMainWindow).  This emits the message
        "GetProjectDirectory" so there must be a listener defined that will return the
        project directory or it will fail and return.
        """

        QDialog.__init__(self, parent, "Import Source Dialog", 1)

        
        
        
        HandlerChild.__init__(self, "import_source_dialog")
        self.parent = parent
        self.projectdir = self.EmitMessage("GetProjectDirectory")
        if not self.projectdir:
            debug(5, "NewPackageDialog::__init__ : no project directory available")
            return

        self.vl1 = QVBoxLayout(self, 10, 10)

        self.instruction = QLabel("""<qt>
        Please enter a name for this package and the location of the
        source code directory tree for it. </qt>""", self)
        self.vl1.addWidget(self.instruction, 0)

        self.grid = QGridLayout(self.vl1, 2, 3, 10, "grid layout")

        self.name_label = QLabel("Package Name: ", self)
        self.grid.addWidget(self.name_label, 0, 0)
        self.name_entry = QLineEdit(self, "")
        self.grid.addMultiCellWidget(self.name_entry, 0, 0, 1, 2)
        self.source_label = QLabel("Source Location: ", self)
        self.grid.addWidget(self.source_label, 1, 0)
        self.source_entry = QLineEdit(self, "")
        self.grid.addWidget(self.source_entry, 1, 1)
        self.browse_button = QPushButton('&Browse', self)
        QObject.connect(self.browse_button, SIGNAL("clicked()"), self.Browse)
        self.grid.addWidget(self.browse_button, 1, 2)


        self.hl1 = QHBoxLayout(self.vl1, 10)
        self.ok_button = QPushButton("&OK", self)
        QObject.connect(self.ok_button, SIGNAL("clicked()"), self.Ok)
        self.hl1.addWidget(self.ok_button)
        self.cancel_button = QPushButton("&Cancel", self)
        QObject.connect(self.cancel_button, SIGNAL("clicked()"), self.Cancel)
        self.hl1.addWidget(self.cancel_button)
        self.status = -1

        self.vl1.activate()
        self.exec_loop()

    def Browse(self):
        """This is a slot for the browse button that opens a file dialog box.  Used
        to browse the filesystem for the source files"""
        self.source_entry.setText(QFileDialog.getExistingDirectory(self.projectdir))

    def GetSourceLocation(self):
        return self.source_location

    def GetPackageName(self):
        return self.package_name

    def GetStatus(self):
        """Return the status.  status can be:
            -1 => still being shown
            0  => Cancel was clicked
            1  => OK was clicked
        """
        return self.status

    def Ok(self):
        """This is the slot for the OK button.  It checks to make sure
        that the name and source file path are both valid and closes the dialog if they are.
        If they aren't then a warning is shown and the dialog box stays up.
        """
        self.package_name = str(self.name_entry.text()).strip()
        self.source_location = str(self.source_entry.text())
        if self.package_name.strip() == "":
            QMessageBox.critical(self, "Bad Package Name", """<qt>
            You did not enter a package name.  Please enter a package name to
            continue.</qt>""")
            return
        if not global_vars.IsValidFilename(self.source_location) or not os.path.isdir(self.source_location):
            QMessageBox.critical(self, "Bad Source Location", """<qt>
            The source directory that you entered is invalid, please enter a
            valid filename to continue</qt>""")
            return
        self.status = 1
        self.accept()

    def Cancel(self):
        """This is the slot for the cancel button.  it sets the status to 0 and
        closes the dialog box"""
        self.status = 0
        self.reject()

    def Help(self):
        """This slot is currently unused, but will connected to a help button
        and will disply context help for the dialog box.

        [FIX THIS to actually work!
        """
        print "help"




class NewPackageDialog(QDialog, HandlerChild):
    """This is the dialog that appears when someone want to create a new package.
    It asks for the name of the package and the path the the source for the package"""
    def __init__(self, parent):
        """The constructor calls the parents' constructors and lays out the widgets.
        It must have a parent (usually this is the QMainWindow).  This emits the message
        "GetProjectDirectory" so there must be a listener defined that will return the
        project directory or it will fail and return.
        """

        QDialog.__init__(self, parent, "NewPackageDialog", 1)

        HandlerChild.__init__(self, "new_package_dialog")
        self.source = ""
        self.name = ""

        self.parent = parent
        self.projectdir = self.EmitMessage("GetProjectDirectory")
        if not self.projectdir:
            debug(5, "NewPackageDialog::__init__ : no project directory available")
            return

        self.vl1 = QVBoxLayout(self, 10, 10)

        self.instruction = QLabel("""<qt>
        Please enter a name for this package and the location of the
        source for it.  If the source is packaged then it must be in tar
        format.  If the source is in a directory, select the directory a tarball
        will be created.
        </qt>""", self)
        self.vl1.addWidget(self.instruction, 0)

        self.grid = QGridLayout(self.vl1, 2, 3, 10, "grid layout")


        self.name_label = QLabel("Package Name: ", self)
        self.grid.addWidget(self.name_label, 0, 0)
        self.name_entry = QLineEdit(self, "")
        self.grid.addMultiCellWidget(self.name_entry, 0, 0, 1, 2)
        self.source_label = QLabel("Source Location: ", self)
        self.grid.addWidget(self.source_label, 1, 0)
        self.source_entry = QLineEdit(self, "")
        self.grid.addWidget(self.source_entry, 1, 1)
        self.browse_button = QPushButton('&Browse', self)
        QObject.connect(self.browse_button, SIGNAL("clicked()"), self.Browse)
        self.grid.addWidget(self.browse_button, 1, 2)


        self.hl1 = QHBoxLayout(self.vl1, 10)
        self.ok_button = QPushButton("&OK", self)
        QObject.connect(self.ok_button, SIGNAL("clicked()"), self.Ok)
        self.hl1.addWidget(self.ok_button)
        self.cancel_button = QPushButton("&Cancel", self)
        QObject.connect(self.cancel_button, SIGNAL("clicked()"), self.Cancel)
        self.hl1.addWidget(self.cancel_button)
        self.status = -1

        self.vl1.activate()
        self.exec_loop()

    def Browse(self):
        """This is a slot for the browse button that opens a file dialog box.  Used
        to browse the filesystem for the source files"""
        self.source_entry.setText(QFileDialog.getOpenFileName(self.projectdir))

    def GetStatus(self):
        """Return the status.  status can be:
            -1 => still being shown
            0  => Cancel was clicked
            1  => OK was clicked
        """
        return self.status

    def Ok(self):
        """This is the slot for the OK button.  It checks to make sure
        that the name and source file path are both valid and closes the dialog if they are.
        If they aren't then a warning is shown and the dialog box stays up.
        """

        self.name = str(self.name_entry.text())
        self.source = str(self.source_entry.text())
        if self.name.strip() == "":
            QMessageBox.critical(self, "Bad Package Name", """<qt>
            You did not enter a package name.  Please enter a package name to
            continue.</qt>""")
            return
        if not global_vars.IsValidFilename(self.source) or not os.path.exists(self.source):
            QMessageBox.critical(self, "Bad Filename", """<qt>
            The source filename that you entered is invalid, please enter a
            valid filename to continue</qt>""")
            return
        self.status = 1
        self.EmitMessage("SetSourceFile", [self.source])
        self.EmitMessage("SetPackageName", [self.name])
        self.accept()

    def GetPackageName(self):
        return self.name

    def GetSourceFile(self):
        return self.source

    def Cancel(self):
        """This is the slot for the cancel button.  it sets the status to 0 and
        closes the dialog box"""
        self.status = 0
        self.reject()

    def Help(self):
        """This slot is currently unused, but will connected to a help button
        and will disply context help for the dialog box.

        [FIX THIS to actually work!
        """
        print "help"

class LogSearchDialog(QDialog, HandlerChild):
    def __init__(self, parent):
        QDialog.__init__(self, parent, "Log Search Dialog", 1)
        HandlerChild.__init__(self, "log_search_dialog", temporary=1) 

class LogPopupMenu(QPopupMenu, HandlerChild):
    """This is the popup menu that appears when someone right clicks in the log
    area"""
    def __init__(self, parent):
        """The constructor just builds the popup menu with items, copy,
        clear, and search"""
        HandlerChild.__init__(self, "log_popup_menu", temporary=1)
        QPopupMenu.__init__(self, parent, "Log Popup Menu")
        self.parent = parent
        self.insertItem("&Copy", self.parent.copy)
        self.insertItem("C&lear", self.parent.ClearWindow)
        self.insertItem("&Search", self.parent.Search)

class LogMultiLine(QMultiLineEdit):
    def __init__(self, parent):
        QMultiLineEdit.__init__(self, parent, "log window")
        self.setReadOnly(1)

    def insert(self, text):
        self.setCursorPosition(1000, 1000)
        self.insertAt(text, 1000, 1000)

    def mousePressEvent(self, e):
        if e.button() == e.RightButton:
            popup = LogPopupMenu(self)
            popup.popup(e.globalPos())
        else:
            return QMultiLineEdit.mousePressEvent(self, e)

    def ClearWindow(self):
        self.setText("")

    def Search(self):
        debug(5, "dummy")




class LogWindow(QFrame):
    def __init__(self, parent, name = "log window"):

        QFrame.__init__(self, parent, name)
        self.log_layout = QVBoxLayout(self)
        self.log_label = QLabel("Log Window", self)
        self.log_layout.addWidget(self.log_label)
        self.log_textarea = LogMultiLine(self)
        self.log_layout.addWidget(self.log_textarea, 1)
        self.build_running = 0
        self.build_pid = 0

    def SendHeader(self, header):
        stars = ((80-len(header))/2) * "*"
        header_str = "\n" + stars + " " + header + " " + stars    + "\n"
        self.log_textarea.insert(header_str)

    def SendText(self, text):
        self.log_textarea.insert(text)
    
    def WinExecuteCommand(self, command, return_log = 0, output_to_window = 1):
        tempfile.tempdir = global_vars.home_drive + "/tmp/"
        self.tmpscr = tempfile.mktemp()
        print "writing temporary file", self.tmpscr
        unix_str = re.sub("\r\n", "\n", command.strip())
        open(self.tmpscr, "w").write("#! /bin/sh \nset -x \nset -e \n" + unix_str + " \n")
        shell_cmd = "/bin/sh " + BuilderPath(self.tmpscr)
        print "command is", shell_cmd
        #create a pipe that the shell proxy will write to and that we
        #can read from
        read_write_lock = thread.allocate_lock()
        (pipe_r, pipe_w) = os.pipe()
    
        #this is a dictionary that we will share between the main thread and the "building" thread
        shared_dict = {"data": "", "keep_thread_alive": 1, "pipe_r": pipe_r, "pipe_w": pipe_w}
        shared_dict["waiting_for_data_lock"] = thread.allocate_lock()
        shared_dict["read_data_lock"] = thread.allocate_lock()
        shared_dict["waiting_for_data_lock"].acquire()
        shared_dict["read_data_lock"].acquire()
        proc = shellprox.Command(shell_cmd, None, pipe_w)
        thread.start_new_thread(self.ThreadedBuild, (shared_dict,))
        log_text = ""
        #go until the process dies or the build is stopped
        while proc.commandStatus == -2:
            time.sleep(.025)
            value = shared_dict["waiting_for_data_lock"].acquire(0)
            #if we got the lock then get the data, put it to the log, and set data to nothing again
            if value == 1:
                if output_to_window:
                    self.log_textarea.insert(shared_dict["data"])
                log_text = log_text + shared_dict["data"]
                shared_dict["data"] = ""
                shared_dict["read_data_lock"].release()
            qApp.processEvents()
        #now we kill the thread by setting a shared variable and writing to the 
        #pipe so that it isn't still blocking on a read
        shared_dict["keep_thread_alive"] = 0
        os.write(shared_dict["pipe_w"], "   ")
        shared_dict["read_data_lock"].release()
        log_text = log_text + shared_dict["data"]
        if output_to_window:
                    self.log_textarea.insert(shared_dict["data"])


        print "in WinExecuteBuildCommand after writing to the pipe, thread should be dead"
        self.build_running = 0
        if return_log:
            return (proc.commandStatus, log_text)
        else:
            return proc.commandStatus                                                  

    def ExecuteCommand(self, command, return_log = 0, output_to_window = 1):
        if global_vars.host == "windows":
            return self.WinExecuteCommand(command, return_log, output_to_window)
        log_text = ""
        self.tmpscr = tempfile.mktemp()
        open(self.tmpscr, "w").write("set -x \n set -e\n" + command + "\n")

        run_str = "/bin/sh " + self.tmpscr + " 2>&1"
        child = popen2.Popen3(run_str)
        rv = fcntl.fcntl(child.fromchild.fileno(), FCNTL.F_SETFL, FCNTL.O_NDELAY)
        status = child.poll()
        while status == -1:
            qApp.processEvents()
            try:
                chars = os.read(child.fromchild.fileno(),1000)
                if output_to_window:
                    self.log_textarea.insert(chars)
                log_text = log_text + chars
            except:
                time.sleep(.1)
            status = child.poll()
        chars = os.read(child.fromchild.fileno(),100000)
        if output_to_window:
            self.log_textarea.insert(chars)
        log_text = log_text + chars
        os.system("rm -f " + self.tmpscr)
        if return_log:
            return (status >> 8, log_text)
        else:
            return status >> 8  

    def StopBuild (self):
        if not self.build_running:
            return
        if global_vars.host == "windows":
            self.build_proc.kill()
        else:
            command = "kill %i" % self.build_pid
            self.ExecuteCommand(command)
        #self.build_running = 0

    def ThreadedBuild(self, shared_dict):
        #here is the classic producer/consumer problem, this thread is the producer
        #we get data, then release the consumer's lock and then wait for the producer lock
        #to be released.  This thread will die when shared_dict["keep_alive_thread"] is set to 0
        while shared_dict["keep_thread_alive"]:
            shared_dict["data"] = os.read(shared_dict["pipe_r"], 1000)
            shared_dict["waiting_for_data_lock"].release()
            shared_dict["read_data_lock"].acquire()
        print "Thread Dying!"
                                                                                       

    def WinExecuteBuildCommand(self, command, return_log = 0, output_to_window = 1):
        tempfile.tempdir = global_vars.home_drive + "/tmp/"
        self.tmpscr = tempfile.mktemp()
        print "writing temporary file", self.tmpscr
        unix_str = re.sub("\r\n", "\n", command.strip())
        open(self.tmpscr, "w").write("#! /bin/sh \nset -x \nset -e \n" + unix_str + " \n")
        shell_cmd = "/bin/sh " + BuilderPath(self.tmpscr)
        print "command is", shell_cmd
        #create a pipe that the shell proxy will write to and that we
        #can read from
        read_write_lock = thread.allocate_lock()
        (pipe_r, pipe_w) = os.pipe()
        
        #this is a dictionary that we will share between the main thread and the "building" thread
        shared_dict = {"data": "", "keep_thread_alive": 1, "pipe_r": pipe_r, "pipe_w": pipe_w}
        shared_dict["waiting_for_data_lock"] = thread.allocate_lock()
        shared_dict["read_data_lock"] = thread.allocate_lock()
        shared_dict["waiting_for_data_lock"].acquire()
        shared_dict["read_data_lock"].acquire()
        self.build_proc = shellprox.Command(shell_cmd, None, pipe_w)
        self.build_running = 1
        thread.start_new_thread(self.ThreadedBuild, (shared_dict,))
        log_text = ""
        #go until the process dies or the build is stopped
        while self.build_proc.commandStatus == -2 and self.build_running:
            time.sleep(.025)
            value = shared_dict["waiting_for_data_lock"].acquire(0)
            #if we got the lock then get the data, put it to the log, and set data to nothing again
            if value == 1:
                if output_to_window:
                    self.log_textarea.insert(shared_dict["data"])
                log_text = log_text + shared_dict["data"]
                shared_dict["data"] = ""
                shared_dict["read_data_lock"].release()
            qApp.processEvents()
        #now we kill the thread by setting a shared variable and writing to the 
        #pipe so that it isn't still blocking on a read
        shared_dict["keep_thread_alive"] = 0
        os.write(shared_dict["pipe_w"], "   ")
        shared_dict["read_data_lock"].release()
        print "in WinExecuteBuildCommand after writing to the pipe, thread should be dead"
        self.build_running = 0
        if return_log:
            return (self.build_proc.commandStatus, log_text)
        else:
            return self.build_proc.commandStatus                                
        
    def ExecuteBuildCommand(self, command, return_log = 0, output_to_window = 1):
        #don't know exactly why, but we need to write a temporary wrapper script
        #in order to get stdin and stdout on our pipes.  We record the pid and then
        #use it to kill the process later if the user desires.
        if global_vars.host == "windows":
            return self.WinExecuteBuildCommand(command, return_log, output_to_window)
        self.build_running = 1
        log_text = ""
        self.tmpscr = tempfile.mktemp()
        open(self.tmpscr, "w").write("#! /bin/sh\nset -x \n set -e\n" + command + "\n")
        os.chmod(self.tmpscr, 0777)
        run_str = self.tmpscr + " 2>&1"
        child = popen2.Popen3(run_str)
        self.build_pid = child.pid
        rv = fcntl.fcntl(child.fromchild.fileno(), FCNTL.F_SETFL, FCNTL.O_NDELAY)
        status = child.poll()
        
        while status == -1:
            qApp.processEvents()
            try:
                chars = os.read(child.fromchild.fileno(),1000)
                if output_to_window:
                    self.log_textarea.insert(chars)
                log_text = log_text + chars
            except:
                time.sleep(.1)
            status = child.poll()
        try:
            chars = os.read(child.fromchild.fileno(),100000)
        except:
            pass
        if output_to_window:
            self.log_textarea.insert(chars)
        log_text = log_text + chars
        os.system("rm -f " + self.tmpscr)
        self.build_running = 0
        if return_log:
            return (status >> 8, log_text)
        else:
            return status >> 8  



class LPFDialog(QDialog, HandlerChild):
    def __init__(self, parent):
        QDialog.__init__(self, parent, "LPFDialog", 1)
        HandlerChild.__init__(self, "lpf_dialog")

        self.parent = parent

        self.projectdir = self.EmitMessage("GetProjectDirectory")
        if self.projectdir == None:
            debug(5, "LPFDialog::__init__ no project directory available")
            return
        self.source_file = self.EmitMessage("GetLBCField", ["pkg_file"])
        if self.source_file == None:
            debug(5, "LPFDialog::__init__ no source file available")
            return
        self.package_name = self.EmitMessage("GetPackageName")
        if self.package_name == None:
            debug(5, "LPFDialog::__init__ no package name available")
            return
        self.ecd_file = self.EmitMessage("GetECDName")
        if self.ecd_file == None:
            debug(5, "LPFDialog::__init__ no ecd name available")
            return


        self.setCaption("Make LPF for %(package_name)s" % self.__dict__)

        self.vl1 = QVBoxLayout(self, 10, 10)

        self.instructions = QLabel("""<qt>Please enter the requested information below for
            this package.
            <ul>
            <li><b>Version</b> - Package version number</li>
            <li><b>Revision number</b> - Revision number of the package</li>
            <li><b>Vendor</b> - The organization that created the package</li>
            <li><b>Support Contact</b> - Technical support e-mail address.</li>
            </ul></qt>""", self)
        self.vl1.addWidget(self.instructions)

        self.layouts = {}
        self.labels = {}
        self.entries = {}

        self.MakeLPFEntry("version", "Version")
        self.MakeLPFEntry("revision", "Revision")
        self.MakeLPFEntry("vendor", "Vendor")
        self.MakeLPFEntry("contact", "Support Contact")

        self.grid = QGridLayout(self.vl1, 2, 2, 10, "lpf_grid_layout")

        self.grid.addLayout(self.layouts["version"], 0, 0)
        self.grid.addLayout(self.layouts["revision"], 0, 1)
        self.grid.addLayout(self.layouts["vendor"], 1, 0)
        self.grid.addLayout(self.layouts["contact"], 1, 1)

        self.hl1 = QHBoxLayout(self.vl1, 10)
        self.ok_button = QPushButton("&OK", self)
        QObject.connect(self.ok_button, SIGNAL("clicked()"), self.Ok)
        self.hl1.addWidget(self.ok_button)
        self.cancel_button = QPushButton("&Cancel", self)
        QObject.connect(self.cancel_button, SIGNAL("clicked()"), self.Cancel)
        self.hl1.addWidget(self.cancel_button)
        self.show()


    def MakeLPFEntry(self, name, label):
        self.layouts[name] = QVBoxLayout()
        self.labels[name] = QLabel(label, self)
        self.entries[name] = QLineEdit(self, "")
        self.layouts[name].addWidget(self.labels[name], 0, QLabel.AlignBottom)
        self.layouts[name].addWidget(self.entries[name], 0, QLabel.AlignTop)

    def Ok(self):
        #This is a dialog box that appears as we make the lpf
        wait_box = widgets.WaitBox(self, "Creating LPF.  Please wait...")
        wait_box.show()

        projectdir = global_vars.BuilderPath(self.projectdir)
        pcf_dict = {}
        for key in ["version", "revision", "vendor", "contact"]:
            pcf_dict[key] = str(self.entries[key].text())

        pcf_dict["type"] = "EMBEDIX PACKAGE"
        pcf_dict["package_name"] = self.package_name
        pcf_dict["build_control"] = self.package_name + ".lbc"
        pcf_dict["config"] = os.path.basename(self.ecd_file)
        pcf_dict["install_scope"] = "GLOBAL_SCOPE"
        pcf_dict["min_update_wizard_version"] = "2.3"
        patches = self.EmitMessage("GetLBCField", ["patches"])
        pcf_dict["source"] = self.source_file + "\n" + patches

        lpf_file_name = "%(package_name)s-%(version)s-%(revision)s.lpf" % pcf_dict
        pcf_file_name = "%(package_name)s.pcf" % pcf_dict

        pcf_dict["all_files"] = pcf_file_name + "\n%(source)s\n%(config)s\n%(build_control)s" % pcf_dict

        command = """
            if [ -e "%(projectdir)s/lpf" ] ; then rm -rf %(projectdir)s/lpf; fi
            mkdir -p %(projectdir)s/lpf
            """ % vars()
        status = log.ExecuteCommand(command)
        print "status is", status
        if status != 0:
            wait_box.hide()
            debug(5, "LPFDialog::Ok could not create directory")
            self.Error("Could not create lpf directory at %(projectdir)s/lpf" % vars())
        pcf_fd = open(self.projectdir + "/lpf/" + pcf_file_name, "w")
        for key in pcf_dict.keys():
            pcf_fd.write("%"+key+"\n")
            pcf_fd.write(pcf_dict[key].strip() + "\n\n")
        pcf_fd.close()
        self.parent.WriteECD(global_vars.HostPath(projectdir + "/lpf/" + pcf_dict["config"]))
        self.EmitMessage("WriteFullLBCFile", [global_vars.HostPath(projectdir + "/lpf/" + pcf_dict["build_control"])])
        for line in pcf_dict["source"].split("\n"):
            if line.strip() == "":
                continue
            path = self.GetSourcePath(line)
            if path == None:
                wait_box.hide()
                debug(5, "LPFDialog::Ok : could not find file %s" % line)
                self.Error("Could not find source/patch file %s" % line)
                return
            status = log.ExecuteCommand("cp %(path)s %(projectdir)s/lpf/" % vars())
            print "status is", status
            if status != 0:
                wait_box.hide()
                debug(5, "LPFDialog::OK : could not copy file %s into lpf directory" % path)
                self.Error("Could not copy source file %s into lpf directory" % path)
                return

        command = """
        cd %(projectdir)s/lpf
        tar -zcvf %(lpf_file_name)s *
        cp %(lpf_file_name)s %(projectdir)s/
        rm -rf %(projectdir)s/lpf
        """ % vars()
        status = log.ExecuteCommand(command)
        print "status is", status
        if status != 0:
            wait_box.hide()
            self.Error("Could not create tar file from lpf directory contents")
            return
        wait_box.hide()
        QMessageBox.information(self, "%s LPF Created Successfully" % self.package_name, """<qt>
        An LPF has successfully been created for the %s package.  It is located at:<br>
        <b>%s</b><br>
        This LPF may be distributed to other users of the Embedix SDK 2.0.  To use this package on a project,
        use the Update Wizard to unpack it.</qt>""" % (self.package_name, global_vars.HostPath(projectdir + "/" + lpf_file_name)), QMessageBox.Ok)
        self.accept()

    def GetSourcePath(self, file_name):
        check_path = os.path.join(self.projectdir + "/Packages", "%s", file_name)
        for dir in ["local", "board", "generic"]:
            if os.path.exists(check_path % dir):
                return global_vars.BuilderPath(check_path % dir)
        return None


    def Error(self, string):
        QMessageBox.critical(self, "Error Creating %s LPF" % self.package_name, "<qt>" + string + "</qt>", QMessageBox.Ok)

    def Cancel(self):
        self.reject()


class PackageWin(QMainWindow, HandlerChild):
    __doc__ = """
    This is the main window that is shown for the package editor.  It also acts as the main control
    sending and receiving messages between member widgets and classes
    """

    def __init__(self, parent):
        QMainWindow.__init__(self, None, "Package Editor")
        global log
        
        QObject.connect(qApp, SIGNAL("lastWindowClosed()"), self.Quit)

        self.SetupHandler()

        #initialize the database
        self.database = {}

        self.setIcon(QPixmap(twlogo_xpm))

        #create the splitter
        self.splitter = QSplitter(QSplitter.Vertical, self, "splitter")
        self.statusBar().message("Ready", 10000)
        self.setCentralWidget(self.splitter)


        #create the top part of the splitter.  It's a tab widget with
        #tabs for lbc, ecd, etc.
        self.tab_frame = QTabWidget(self.splitter)
        #self.splitter.setResizeMode(self.tab_frame, QSplitter.FollowSizeHint)

        #create the bottom part of the splitter, the log
        self.log = LogWindow(self.splitter)
        global_vars.Setlog(self.log)
        self.splitter.setResizeMode(self.log, QSplitter.Stretch)
        log = self.log

        #create the lbc tab and frame
        self.lbc_frame = LBCFrame(self.tab_frame, self)
        self.tab_frame.addTab(self.lbc_frame, "LBC File")

        #create the ecd tab and frame
        self.ecd_controller = ECDController(self, self)
        self.tab_frame.addTab(self.ecd_controller.GetECDFrame(), "ECD File")

        self.ecd_frame = self.ecd_controller.GetECDFrame()
        
        #create the source tab and frame
        self.source_frame = SourceFrame(self.tab_frame, self)
        self.tab_frame.addTab(self.source_frame, "Source")
        self.source_frame.RegisterLogger(self.log)

        #instantiate the builder
        self.builder = Builder(self)
        self.builder.RegisterLogger(self.log)

        #set the caption and create the menu and toolbar
        self.setCaption("Package Editor")
        self.SetupActions()
        self.SetupMenus()                                             
        self.SetupToolbars()

        self.lbc_frame.setEnabled(0)
        self.package_open = 0
        debug(5, self.database)
        
        self.splitter.refresh()

    def Connect(self, linux_host_ip = None):
        if global_vars.host == "windows":
            if linux_host_ip == None:
                linux_host_ip = global_vars.ip
            print "Connecting to vmware session"
            wait_box = QDialog(self, "wait dialog box")
            vl1 = QVBoxLayout(wait_box, 10)
            l = QLabel("Connecting to VMWare Session at %s.  Please wait..." % linux_host_ip, wait_box)
            vl1.addWidget(l)            
            vl1.activate()
            wait_box.show()

            qApp.processEvents()
            try:
                shellprox.MainShellAccessProxy.connect(linux_host_ip)
            except:
                pass
            if shellprox.REMOTE_CONNECTED == 0:
                QMessageBox.warning(self, "Network Connection Error", """<qt>
                There was an error connecting to host %s.  You may continue to work 
                on packages, but you will not be able to test building or use any other
                functions that need linux to operate.</qt>""" % linux_host_ip)
            wait_box.hide()



    def SetupHandler(self):
        HandlerChild.__init__(self, "main_window")
        self.SetListener("GetProjectDirectory", self.GetProjDir)
        self.SetListener("SetProjectDirectory", self.SetProjDir)
        self.SetListener("GetPackageName", self.GetPackageName)
        self.SetListener("SetPackageName", self.SetPackageName)
        self.SetListener("GetBuildDirectory", self.GetBuildDir)
        self.SetListener("SetBuildDirectory", self.SetBuildDir)
        self.SetListener("GetSourceFile", self.GetSourceFile)
        self.SetListener("SetSourceFile", self.SetSourceFile)
        self.SetListener("GetECDName", self.GetECDName)
        self.SetListener("SetECDName", self.SetECDName)
        self.SetListener("SetTabModified", self.SetTabModified)

    #call this with the name of the tab and the status
    #status is 1 if the tab has been modified and 0 if the tab
    # has just been saved (not modified)
    def SetTabModified(self, tab_name, status):
        if status == 0:
            new_name = tab_name
        else:
            new_name = tab_name + " (*)"
        if tab_name == "LBC File":
            self.tab_frame.changeTab(self.lbc_frame, new_name)
        elif tab_name == "ECD File":
            self.tab_frame.changeTab(self.ecd_frame, new_name)
        elif tab_name == "Source":
            self.tab_frame.changeTab(self.source_frame, new_name)
        else:
            debug(9, "SetTabModified :: called with tab_name = %s" % tab_name)
        return
    

    def show(self):
        #set constraints on size
        if global_vars.settings.has_key("geometry"):
            lines = global_vars.settings["geometry"].split("\n")
            if len(lines) > 0:
                x, y, w, h = map(int, lines[0].split())
                self.setGeometry(x, y, w, h)
            if len(lines) > 1:
                self.splitter.setSizes(map(int, lines[1].split()))
            if len(lines) > 2:
                self.ecd_controller.splitter.setSizes(map(int, lines[2].split()))
        QMainWindow.show(self)
        self.Connect()

    def ImportUserSource(self):
        self.ClosePackage()
        import_d = ImportSourceDialog(self)
        if import_d.GetStatus() != 1:
            return
        source_location = import_d.GetSourceLocation()
        package_name = import_d.GetPackageName()

        self.log.SendHeader("source is located at %s" % source_location)
        if source_location[-1] == "/":
            source_location = source_location[:-1]
        (base_dir, source_dir) = os.path.split(source_location)
        #if this is on windows then we need to do move the tree onto the linux
        #side before tarring it up
        if global_vars.host == "windows":
            host_tmp_path = global_vars.HostPath("/home/vkit/tmp/" + source_dir)
            if os.path.exists(host_tmp_path):
                shutil.rmtree(host_tmp_path)
            shutil.copytree(source_location, host_tmp_path)
            base_dir = "/home/vkit/tmp/"

        base_dir = global_vars.BuilderPath(base_dir)
        project_dir = global_vars.BuilderPath(self.GetProjDir())
        command = """
        cd %(base_dir)s
        tar zcvf %(package_name)s.tgz %(source_dir)s
        mv -f %(package_name)s.tgz %(project_dir)s/Packages/local
        """     % locals()
        self.log.ExecuteCommand(command)
        self.SetPackageName(package_name)
        self.SetSourceFile(package_name + ".tgz")
        self.lbc_frame.MakeMinimalLBC(package_name + ".tgz", project_dir + "config-data/buildcontrol/local/" + package_name + ".lbc")
        ecd_filename = HostPath(project_dir + "/config-data/ecds/local/" + package_name + ".ecd")
        self.ecd_controller.MakeMinimalECD(package_name, ecd_filename)
        self.OpenPackage(ecd_filename)

    
    def NewPackage(self):
        self.ClosePackage()
        new_pack_d = NewPackageDialog(self)
        if new_pack_d.GetStatus() != 1:
            return
        source_file = new_pack_d.GetSourceFile()
        package_name = new_pack_d.GetPackageName()
        self.SetSourceFile(source_file)
        self.SetPackageName(package_name)
        self.log.SendText("\n=========== copying source file to this project's packages directory =======\n")
        self.log.ExecuteCommand("cp %(source_file)s %(projectdir)s/Packages/local" % self.__dict__)
        self.lbc_frame.MakeMinimalLBC(self.source_file, self.lbc_frame.MakeMinimalLBC(package_name + ".tgz", project_dir + "config-data/buildcontrol/local/" + package_name + ".lbc"))
        self.ecd_controller.MakeMinimalECD(self.package_name)
        project_dir = self.GetProjDir()
        self.OpenPackage(HostPath(project_dir + "/config-data/ecds/local/" + package_name + ".ecd"))


    def SelectPackage(self):
        #get the names of all available ecds (in local, generic, and board
        glob_list = glob.glob(HostPath("%s/config-data/ecds/*/*.ecd" % self.GetProjDir()))
        
        #get rid of duplicates and leading paths and the .ecd endings
        ecd_list = []
        for ecd_name in glob_list:
            ecd_name = os.path.basename(ecd_name)[:-4]
            if not ecd_name in ecd_list:
                ecd_list.append(ecd_name)

        ecd_list.sort()

        #create a list of strings of the ecd names
        l = QStringList()
        for ecd_name in ecd_list:
            l.append(ecd_name)
        caption = "Open SDK Package"
        label = "<qt><center>Please select an SDK package to open</center></qt>"
        #present the dialog and get the result
        (ecd_name, ok_flag) = QInputDialog.getItem(caption, label, l, 0, 0, self)

        #if they pressed cancel then return the emptry string
        if ok_flag == 0:
            return ""
        
        #look for the specified ecd hierarchically
        for path in ["local", "board", "generic"] :
            path_string = "%s/config-data/ecds/%s/%s.ecd" % (self.GetProjDir(), path, ecd_name)
            if os.path.exists(HostPath(path_string)):
                return path_string

        #if we couldn't find it the return the empty string
        return ""  

    #this is called before closing a package.  It checks to see if modifications
    #have been made and asks to save if they have.
    #this will return a 0 if the user selected the cancel button and 1 if they
    #clicked yes or no (meaning they want to continue)
    def SaveModifications(self):
        #if something has been modified then let's ask to save it.
        if self.lbc_frame.GetModified():
            answer = QMessageBox.warning(self, "LBC File has changed!",
                """<qt>You have made modifications to the LBC for this package.  Would you
                like to save those changes before reloading the LBC?</qt>""", "&Yes", "&No", "&Cancel", 0, 2)
            #if they clicked on cancel then return
            if answer == 2:
                return 0 #return a 0 because they cancelled
            if answer == 0:
                self.WriteLBC()
        if self.ecd_controller.GetModified():
            answer = QMessageBox.warning(self, "ECD File has changed!",
                """<qt>You have made modifications to the ECD for this package.  Would you
                like to save those changes before reloading the ECD?</qt>""", "&Yes", "&No", "&Cancel", 0, 2)
            #if they clicked on cancel then return
            if answer == 2:
                return 0 #return a 0 because they cancelled
            if answer == 0:
                self.WriteECD()
        return 1 #return one meaning they did not cancel
     
    def OpenPackage(self, new_ecd_name = None):
        cancel = not self.SaveModifications()
        if cancel:
            return
        
        if new_ecd_name and str(new_ecd_name) == new_ecd_name:
            self.ecd_name = new_ecd_name
        else:
            new_ecd_name = self.SelectPackage()
            if new_ecd_name == "":
                debug(5, "OpenPackage: open was cancelled\n")
                return
            self.ecd_name = new_ecd_name
        

        self.ClosePackage(save_modifications = 0)
        self.ecd_controller.ReadECD(self.ecd_name)
        self.SetPackageName(self.ecd_controller.GetPackageName())
        self.lbc_frame.GetLBC(self.projectdir, self.package_name.replace("-", "_"))
        self.source_frame.OpenPackage()
        global_vars.settings["last_package"] = os.path.basename(self.ecd_name)[:-4] #cut off the .ecd portion and only write the basename
        global_vars.settings.WriteSettings()
        caption_str = "Packager : %s Package for %s project" % (self.GetPackageName(), self.GetProjDir())
        self.setCaption(caption_str)
     
    def MakeLPF(self):
        lpf_dialog = LPFDialog(self)
     
    def SetupToolbars(self):
        self.pixmap_dir = "/opt/Embedix/lwiz1.0/images/"
        self.toolbar = QToolBar("ToolBar", self)
        self.save_lbc_action.addTo(self.toolbar)
        self.reload_lbc_action.addTo(self.toolbar)
        self.toolbar.addSeparator()
        self.save_ecd_action.addTo(self.toolbar)
        self.reload_ecd_action.addTo(self.toolbar)
        
        
        self.toolbar.addSeparator()
        self.source_save_pixmap = QPixmap(source_save_xpm)
        self.source_save_button = QToolButton(self.source_save_pixmap, "Save Source File", "Save Source File", self.source_frame.SaveFile, self.toolbar)
        
        self.stop_build_action.addTo(self.toolbar)
        self.addToolBar(self.toolbar, "Tool Bar")

    def MakeAction(self, text, menu_text, accel, parent, name, receiver, icon=None, toggle=0):
        action = QAction(text, menu_text, accel, parent, name, toggle)
        if icon:
            action.setIconSet(QIconSet(icon))
        QObject.connect(action, SIGNAL("activated()"), receiver)
        return action


    def SetupActions(self):
        ############# set up the file actions ##################
        self.file_actions = QActionGroup(self, "file action group", 0)
        self.open_package_action = self.MakeAction("Open Package", "&Open Package", Qt.CTRL + Qt.Key_O, 
            self.file_actions, "Open Package Action", self.OpenPackage)
        self.new_package_action = self.MakeAction("New Package",  "&New Package", Qt.CTRL + Qt.Key_P, 
            self.file_actions, "New Package Action", self.NewPackage)
        self.import_source_action = self.MakeAction("Import Source as a Package",  "&Import Source as a Package", Qt.CTRL + Qt.Key_I, 
            self.file_actions, "Import Source Action", self.ImportUserSource)
        self.close_package_action = self.MakeAction("Close Package",  "&Close Package", Qt.ALT + Qt.Key_C,
            self.file_actions, "Close Package Action", self.ClosePackage)
        self.make_lpf_action = self.MakeAction("Make LPF",  "Make &LPF", Qt.CTRL + Qt.Key_L, 
            self.file_actions, "Make LPF Action", self.MakeLPF)
        self.quit_action = self.MakeAction("Quit",  "&Quit", Qt.CTRL + Qt.Key_Q, self.file_actions,
            "Quit Action", self.close)
        
        ############# set up the settings actions ##############
        self.settings_actions = QActionGroup(self, "settings action group", 0)
        self.editor_action = self.MakeAction("Editor", "&Editor", 0, 
            self.settings_actions, "editor action", self.Dummy)

        ############ set up build actions #####################
        self.build_actions = QActionGroup(self, "build action group")
        self.force_config_action = self.MakeAction("Force Configure", "Force &Configure", 0,
            self.build_actions, "force configure action", self.builder.ForceConfig)
        self.make_action = self.MakeAction("Make", "&Make", 0,
            self.build_actions, "make action", self.builder.Make)
        self.make_install_action = self.MakeAction("Make Install", "Make &Install", 0,
            self.build_actions, "make install action", self.builder.MakeInstall)
        self.force_cmi_action = self.MakeAction("Force Configure, Make, Install", "Force Configure, Make, Install", 0,
            self.build_actions, "force cmi action", self.builder.ForceCMI)
        self.force_unpack_action = self.MakeAction("Force Unpack Sources", "Force Unpack &Sources", 0,
            self.build_actions, "force unpack action", self.builder.ForceUnpack)
        self.force_ucmi_action = self.MakeAction("Force Unpack, Configure, Make, Install", "Force Unpack, Configure, Make, Install",
            0, self.build_actions, "force ucmi action", self.builder.ForceUCMI)
        self.force_complete_action = self.MakeAction("Force Complete Rebuild", "Force Complete Rebuild", 0,
            self.build_actions, "force rebuild action", self.builder.ForceCompleteBuild)
        self.make_clean_action = self.MakeAction("Make Clean", "Make Clean", 0,
            self.build_actions, "make clean action", self.builder.MakeClean)
        self.stop_build_action = self.MakeAction("Stop Build", "Stop Build", 0,
            self.build_actions, "stop build action", self.builder.StopBuild, QPixmap(stop_xpm))

        ########### set up lbc actions #########################
        self.lbc_actions = QActionGroup(self, "lbc action group", 0)
        self.get_build_dir_Action = self.MakeAction("Determine Build Directory", "Determine Build Directory From Source", 
            0, self.lbc_actions, "get build dir action", self.lbc_frame.DetermineBuildDirectory)
        self.reload_lbc_action = self.MakeAction("Reload LBC", "&Reload LBC", 0,
            self.lbc_actions, "reload lbc action", self.ReloadLBC, QPixmap(lbc_open_xpm))
        self.save_lbc_action = self.MakeAction("Save LBC", "&Save LBC", 0,
            self.lbc_actions, "save lbc action", self.WriteLBC, QPixmap(lbc_save_xpm))
        self.save_lbc_as_action = self.MakeAction("Save LBC as", "Save LBC &as", 0,
            self.lbc_actions, "save lbc as action", self.Dummy)
        self.view_configure_help_action = self.MakeAction("View configure --help", "View configure --help", 0,
            self.lbc_actions, "view configure help action", self.lbc_frame.ViewConfigureHelp)

        
        ############## set up ecd actions #######################
        self.ecd_actions = QActionGroup(self, "ecd action group", 0)
        self.reload_ecd_action = self.MakeAction("Reload ECD", "&Reload ECD", 0,
            self.ecd_actions, "reload ecd action", self.ReloadECD, QPixmap(ecd_open_xpm))
        self.save_ecd_action = self.MakeAction("Save ECD", "&Save ECD", 0,
            self.ecd_actions, "save ecd action", self.WriteECD, QPixmap(ecd_save_xpm))
        self.save_ecd_as_action = self.MakeAction("Save ECD as", "Save ECD &as", 0,
            self.ecd_actions, "save ecd as action", self.Dummy)

        ################## set up settings actions #####################
        self.settings_actions = QActionGroup(self, "settings action group", 0)
        self.editor_settings_action = self.MakeAction("Editor", "&Editor", 0,
            self.settings_actions, "editor settings", self.DoSettings)
        self.save_geometry_action = self.MakeAction("Save Geometry", "Save &Geometry", 0,
            self.settings_actions, "save geometry action", self.SaveGeometry)
        
        ################ set up source actions #########################
        self.source_actions = QActionGroup(self, "source actions group", 0)
        self.prepare_source_action = self.MakeAction("Prepare Source for work", "&Prepare Source for Work", 0,
            self.source_actions, "prepare source action", self.source_frame.PreparePackageSource)
        self.reload_dir_action = self.MakeAction("Reload Directory", "&Reload Directory", 0,
            self.source_actions, "reload directory action", self.source_frame.OpenPackage)
        self.make_patch_action = self.MakeAction("Make Patch", "Make &Patch", 0,
            self.source_actions, "make patch action", self.source_frame.MakePatch)
        self.editor_item_action = self.MakeAction("Open Current File in Editor", "&Open Current File in Editor", 0,
            self.source_actions, "open file in editor", self.Dummy)
        self.reload_file_action = self.MakeAction("Reload Current File", "&Reload Current File", 0,
            self.source_actions, "reload file action", self.source_frame.LoadFile)
        self.save_file_action = self.MakeAction("Save Current File", "&Save Current File", 0,
            self.source_actions, "save file action", self.source_frame.SaveFile)
        self.diff_mode_action = self.MakeAction("View diff instead of file", "View &Diff instead of file", 0,
            self.source_actions, "diff mode actions", self.DiffMode, None, 1)
        self.diff_mode = 0
        self.diff_mode_action.setToggleAction(1)



    def SetupMenus(self):
        self.splitter.refresh()
        global handler
        self.menu_bar = QMenuBar(self, "Main menu bar")
        #setup file menu
        self.file_menu = QPopupMenu(self.menu_bar, "file menu")
        self.file_actions.addTo(self.file_menu)
        #setup settings menu
        self.settings_menu = QPopupMenu(self.menu_bar, "settings menu")
        self.settings_actions.addTo(self.settings_menu)
        #setup Build popup menu
        self.build_menu = QPopupMenu(self.menu_bar, "Build Menu")
        self.build_actions.addTo(self.build_menu)
        #this is the LBC popup menu
        self.lbc_menu = QPopupMenu(self.menu_bar, "LBC menu")
        self.lbc_actions.addTo(self.lbc_menu)
        #this is the ECD popup menu
        self.ecd_menu = QPopupMenu(self.menu_bar, "ECD menu")
        self.ecd_actions.addTo(self.ecd_menu)
        #this is the source popup menu
        self.source_menu = QPopupMenu(self.menu_bar, "Source menu")
        self.source_actions.addTo(self.source_menu)
        
        #this is the help popup menu
        self.help_menu = QPopupMenu(self.menu_bar, "Help menu")
        self.help_menu.help_item = self.help_menu.insertItem("&Help", self.Dummy)
        self.help_menu.about_item = self.help_menu.insertItem("&About Package Editor", self.Dummy)
        self.help_menu.debug_item = self.help_menu.insertItem("&Print Handler debug", handler.Debug)
        self.help_menu.debug_check = self.help_menu.insertItem("&Debugging", self.ToggleDebug)
        self.help_menu.setItemChecked(self.help_menu.debug_check, debug_level)

        #now place the menus in the menubar
        self.menu_bar.insertItem("&File", self.file_menu)
        self.menu_bar.insertItem("&Settings", self.settings_menu)
        self.menu_bar.insertItem("&Build", self.build_menu)
        self.menu_bar.insertItem("&LBC", self.lbc_menu)
        self.menu_bar.insertItem("&ECD", self.ecd_menu)
        self.menu_bar.insertItem("S&ource", self.source_menu)
        #self.menu_bar.insertItem("&Help", self.help_menu)

    def DoSettings(self):
        settings_obj = global_vars.settings
        settings_obj.RunDialog(self)

    def SaveGeometry(self):
        geom_str = "%i %i %i %i" % (self.frameGeometry().x(), self.frameGeometry().y(), 
                                    self.frameGeometry().width(), self.frameGeometry().height())
        splitter_geometry = string.join(map(str, self.splitter.sizes()), " ")
        ecd_geometry = string.join(map(str, self.ecd_controller.splitter.sizes()), " ")
        #print "sizes are", self.splitter.sizes()
        global_vars.settings["geometry"] = string.join((geom_str, splitter_geometry, ecd_geometry), "\n")
        global_vars.settings.WriteSettings()
        

        #this is used by the diff menu item
    def DiffMode(self):
        if self.diff_mode:
            self.diff_mode = 0
        else:
            self.diff_mode = 1
        
        self.diff_mode_action.setOn(self.diff_mode)
        self.source_frame.SetDiffMode(self.diff_mode)

    def ToggleDebug(self):
        global debug_level
        if debug_level > 0:
            debug_level = 0
        else:
            debug_level = 10
        self.help_menu.setItemChecked(self.help_menu.debug_check, debug_level)

    def Dummy(self):
        debug(5, "Dummy")

    def SavePackage(self):
        self.WriteLPDF()

    def ClosePackage(self, save_modifications = 1):
        if save_modifications:
            cancel = not self.SaveModifications()
            if cancel:
                return
        self.lbc_frame.Close()
        self.ecd_controller.CloseECD()
        self.source_frame.Close()

    def GetECDPathFromName(self, ecd_name):
        if ecd_name.find("ecd") == -1:
            ecd_name = ecd_name + ".ecd"
        path = os.path.join(self.projectdir, "config-data", "ecds", "%s", ecd_name)
        for dir in ["local", "board", "generic"]:
            dir_path = global_vars.HostPath(path % dir)
            if os.path.exists(dir_path):
                return dir_path
        return ""

    def WriteECD(self, ecd_path=None):
        #we have the old ecd_name, but we need to save this ecd in local
        if ecd_path == None:
            base_name = os.path.basename(self.ecd_name)
            ecd_path = os.path.join(self.projectdir, "config-data", "ecds", "local", base_name)
            ecd_path = global_vars.HostPath(ecd_path)
        self.ecd_controller.WriteECD(ecd_path)

    def ReloadECD(self):
       if self.ecd_controller.GetModified():
           answer = QMessageBox.warning(self, "ECD File has changed!",
               """<qt>You have made modifications to the ECD for this package.  Would you
               like to save those changes before reloading the ECD?</qt>""", "&Yes", "&No", "&Cancel", 0, 2)
           #if they anwered yes
           if answer == 2:
               return
           if answer == 0:
               self.WriteECD()
       ecd_path = self.GetECDPathFromName(os.path.basename(self.ecd_name))
       self.ecd_controller.ReadECD(ecd_path)


    def WriteLBC(self):
        lbc_path = os.path.join(self.projectdir, "config-data", "buildcontrol", "local", self.package_name.replace("-", "_"))
        lbc_path = global_vars.HostPath(lbc_path)
        self.lbc_frame.WriteLBC(lbc_path)

    def ReloadLBC(self):
        if self.lbc_frame.GetModified():
            answer = QMessageBox.warning(self, "LBC File has changed!",
                """<qt>You have made modifications to the LBC for this package.  Would you
                like to save those changes before reloading the LBC?</qt>""", "&Yes", "&No", "&Cancel", 0, 2)
            #if they anwered yes
            if answer == 2:
                return
            if answer == 0:
                self.WriteLBC()
        self.lbc_frame.GetLBC(self.projectdir, self.package_name.replace("-", "_"))


    # here is a bunch of get and set methods
    def GetBuildVars(self):
        return self.ecd_controller.GetBuildVars()

    def GetSourceFrame(self):
        return self.source_frame
    def GetLBCFrame(self):
        return self.lbc_frame
    def GetECDFrame(self):
        return self.ecd_frame
    def GetProjDir(self):
        try:
            value = self.projectdir
            return value
        except:
            return None
    def SetProjDir(self, value):
        self.projectdir = value
    def GetPackageName(self):
        try:
            value = self.package_name
            return value
        except:
            return None
    def SetPackageName(self, value):
        self.package_name = value.replace("-", "_")
    def GetBuildDir(self):
        try:
            value = self.lbc_frame.GetField("bld_dir_name")
            return value
        except:
            return None
    def SetBuildDir(self, value):
        self.lbc_frame.SetField("local", "bld_dir_name", value)
    def GetSourceFile(self):
        try:
            value = self.lbc_frame.GetField("pkg_file")
            debug(5, "GetSourceFile::being called")
            debug(5, "value is %s" % value)
            return value
        except:
            return None
    def SetSourceFile(self, value):
        self.source_file = value
    def GetECDName(self):
        try:
            value = self.ecd_name
            return value
        except:
            return None
    def SetECDName(self, value):
        self.ecd_name = value
    
    
    def Quit(self):
        self.SaveGeometry()
    

sequence = "asdf"

def run_wizard(sequence, vars, stand_alone = "yes"):
    if stand_alone == "no":
        project_dir = "/home/chrisb/project/intel1"
        try:
            import PyProjAPI
            print "successfully imported!"
            build_dir = str(PyProjAPI.project_get("build dir")[1])
            project_dir =  os.path.dirname(build_dir[:-1])
            print project_dir
        except:
            print "import failed"

        main_win = PackageWin(qApp)
        main_win.SetProjDir(projectdir)
        main_win.show()

global_vars.Setdebug(debug)
handler = Handler()
global_vars.Sethandler(handler)


def FindProjectDir():
    #start in the current directory and keep going down the tree
    #looking for a .epj file.  This indicates a project directory
    #so return if we find it
    dir = os.getcwd()
    while dir != os.path.dirname(dir):
        epj_files = glob.glob(HostPath(dir + "/*.epj"))
        if len(epj_files) > 0:
            return dir
        dir = os.path.split(dir)[0]
    return ""

def ShowUsage(error_msg = None):
    if error_msg != None:
        print error_msg
    print """
Usage: packager [-d <project directory>] [-p <package name>]

  -d <project directory>    This is the project directory that you would
    like to use. If you do not specify this then the packager will look
    at your current working directory to see if you are in a project tree.
    If so it will use that project's directory.    If you are not in a project
    tree then it will use the last project that you opened with the Package
    Editor.  If all of these methods fail then the packager will show this
    information and quit.

  -p <package name>   This specifies the package to work on.  If it is
    not specified then the packager will open the last package that you used
    in the determined project.  If there was no last package open for the
    project then it will start with no package open.

 --ip <ip address>    If the package editor is started from windows, the ip 
    address of the vmware/linux session must be given so that it can connect
    for building packages.  This may be a dotted quad like 172.27.170.5 or a 
    host name like cbuild.eng.lineo.com

 --drives <home drive>:<opt/Embedix drive>
    If the package editor is started from windows, the names of the two drives
    that are samba mounted need to be passed in. The first drive is the samba 
    mount that corresponds to /home/vkit and the second corresponds to 
    opt/Embedix.  Normally this should look like:  --drives p:q
"""


if __name__ == "__main__":
    
    if global_vars.host == "linux":
        sys.argv.extend(["-bg", "light grey"])
    
    app = QApplication(sys.argv)
    main_win = PackageWin(app)
    app.setMainWidget(main_win)
    (status, args) = ParseArgs(sys.argv)

    #print "argument dictionary", args

    #if there were errors parsing the command line then die
    if status == 0 or args.has_key("help"):
        ShowUsage()
        sys.exit(1)
    
    settings_obj = Settings()
    settings_obj.ReadSettings()
    global_vars.SetSettings(settings_obj)
    
     
    if args.has_key("dir"):
        projectdir = HostPath(os.path.expanduser(os.path.abspath(args["dir"])))
        print "projectdir is", projectdir
    else: 
        projectdir = FindProjectDir()
        if not projectdir:
            if global_vars.settings.has_key("last_projectdir"):
                projectdir = global_vars.settings["last_projectdir"]
            else:
                ShowUsage()
                sys.exit(0)
    
    #print "checking project directory", projectdir
    
    if global_vars.host == "windows":
        if args.has_key("ip"):
            print "ip address is", args["ip"]
            global_vars.ip = args["ip"]
        else:
            ShowUsage("Error: No IP address set!  Please include IP of linux session.")
            sys.exit(1)
        if args.has_key("drives") and len(args["drives"]) == 3:
            global_vars.home_drive = args["drives"][0] + ":"
            global_vars.opt_emb_drive = args["drives"][2] + ":"
        else:
            ShowUsage("Error: Samba drives not specified!")
            sys.exit(1)
    

    if os.path.exists(projectdir):
        proj_files = glob.glob(projectdir + "/*.epj")
        if len(proj_files) == 0:
            print "It doesn't look like %s is a real project directory"    % projectdir
            print "Please specify a real project directory with the -pd option"
            ShowUsage()
            sys.exit(0)
        print "Loading Project Directory:", projectdir
        main_win.SetProjDir(projectdir)
        global_vars.settings["last_projectdir"] = projectdir
        global_vars.settings.WriteSettings()
    else:
        ShowUsage()
        sys.exit(0)
    
    package = ""
    if args.has_key("pkg"):
        package = args["pkg"]
    elif global_vars.settings.has_key("last_package"):
        package = global_vars.settings["last_package"]
    if package:
        path = os.path.join(projectdir, "config-data/ecds/%s", package + ".ecd")
        path = HostPath(path)
        if os.path.exists(path % "local"):
            main_win.OpenPackage(path % "local")
        elif os.path.exists(path % "board"):
            main_win.OpenPackage(path % "board")
        elif os.path.exists(path % "generic"):
            main_win.OpenPackage(path % "generic")
        else:
            print "Could not find ecd for package %s" % package
    
    main_win.show()
    app.exec_loop()

