from message_handler import *
from qt import *
from widgets import *
import global_vars, wizutil
import settings_dialog

HostPath = global_vars.HostPath
if global_vars.host == "windows":
    settings_filename = "packager.conf"
else:
    settings_filename = ".packager.conf"


class SettingsDialog(settings_dialog.SettingsDialog):
    def __init__ (self, parent, dict):
        settings_dialog.SettingsDialog.__init__(self, parent, "Settings Dialog", 1)
        QObject.connect(self.editor_button, SIGNAL("clicked()"), self.EditorBrowse)
        self.editor_path = dict.get("editor_path", "")
        self.editor_lineedit.setText(self.editor_path)

    def EditorBrowse(self):
        editor_path = str(QFileDialog.getOpenFileName())
        if editor_path == "":
            return
        self.editor_lineedit.setText(editor_path)

    def accept(self):
        self.editor_path = str(self.editor_lineedit.text())
        settings_dialog.SettingsDialog.accept(self)

    def GetEditorPath(self):
        return self.editor_path
    
    
class Settings:
    def __init__(self):
        self.dict = {}
        if global_vars.host == "windows":
            os.environ["HOME"] = "/home/vkit" 

    def RunDialog(self, parent):
        sd = SettingsDialog(parent, self.dict)
        result = sd.exec_loop()
        if result == sd.Accepted:
            self["editor_path"] = sd.GetEditorPath()
            #print "The editor path is", self.dict["editor_path"]
        self.WriteSettings()

    def get(self, key, default):
        return self.dict.get(key, default)
    
    def __getitem__(self, key):
        return self.dict[key]

    def __setitem__(self, key, value):
        self.dict[key] = value

    def has_key(self, key):
        return self.dict.has_key(key)

    def keys(self):
        return self.dict.keys()

    def WriteSettings(self, filename = None):
        if filename == None:
            filename = HostPath(os.path.join(os.environ["HOME"], settings_filename))
        #print "writing settings to", filename
        wizutil.write_config(filename, self.dict, self.dict.keys())

    def ReadSettings(self, filename = None):
            if not filename:
                filename = HostPath(os.path.join(os.environ["HOME"], settings_filename))
            if os.path.exists(filename):
                self.dict.update(wizutil.parse_config(filename))
                for key in self.dict.keys():
                    self.dict[key] = self.dict[key].strip()




